	TITLE	'Single Density Format Program 10-26-82'
;
; single density disk formatting program
;
; this program will format either a single
; sided or a double sided disk and check
; each track for crc or rnf errors. if any
; errors of this type are found, the program
; will reformat that track again, recheck it
; again, for 5 retrys. if the retry count
; exceeds 5, then that disk is declared fatal
; and should be replaced.
;
IOBASE	EQU	80H		;i/o base address of cpz-48000
DCOM	EQU	IOBASE+10H	;disk command port
DSTAT	EQU	DCOM		;disk status port
FTRK	EQU	DCOM+1		;floppy track register
SECTP	EQU	DCOM+2		;disk sector port
DDATA	EQU	DCOM+3		;disk data port
DCONT	EQU	IOBASE+52H	;disk control port
WAIT	EQU	IOBASE+53H	;disk wait port
CR	EQU	0DH
LF	EQU	0AH
BELL	EQU	'G'-40H		;cntl-g = bell
READC	EQU	80H		;read command
RSTOR	EQU	0		;restore command
STEP	EQU	01010000B	;step in command
HLAB	EQU	8		;0=no head load, 8=head load
STPRAT	EQU	1		;0=3ms,1=6ms,2=10ms
RCB	EQU	10		;read command buffer
BDOS	EQU	5		;bdos entry point
;
BEGIN:	ORG	0100H		;load & ex here
	JMP	BGIN		;jump around messages
;
MSG:	DB	CR,LF,'I.C.M. Single Density,Single Sided',CR,LF
	DB	'Single Density,Double Sided Format Program',CR,LF
	DB	'Version 1.4  dated 10-26-82',CR,LF
	DB	CR,LF,'Formats 76 tracks',CR,LF
	DB	'26 sectors/track with 128 bytes/sector',CR,LF
CRLF:	DB	CR,LF,'$'
RDY:	DB	'Format System, All or Quit (S,A or Q)? $'
DRIVE:	DB	CR,'Drive to format (A,B,C,D) or Q to quit? $'
DUBMSG:	DB	CR,LF,'Format a Double Sided Disk (Y or N)? $'
;
ERROR:	DB	BELL,CR,LF
	DB	'*********************************************',CR,LF
	DB	'*					    *',CR,LF
	DB	'*       E R R O R  in formatting disk       *',CR,LF
	DB	'*					    *',CR,LF
	DB	'*********************************************',CR,LF
	DB	CR,LF,'Check for write protected disk',CR,LF
	DB	BELL,'$'
DISKER:	DB	BELL,CR
	DB	'*********************************************',CR,LF
	DB	'*					    *',CR,LF
	DB	'*    Fatal disk errors, try another disk    *',CR,LF
	DB	'*					    *',CR,LF
	DB	'*********************************************',CR,LF
	DB	BELL,'$'
;
;starting message
;	
BGIN:	SSPD	OLDSTK		;save it for later
	LXI	SP,STACK	;set up local stack
	LXI	D,MSG		;get adr of message.
	CALL	ENTRY		;print opening.
BGIN2:	MVI	A,0E5H		;reset to single sided
	STA	SPBYTE+1
	LXI	D,DRIVE		;get drive to format
	CALL	ENTRY		;print message
	CALL	INPUT
	CPI	'Q'		;quit?
	JRZ	EXIT		;yes
	ANI	7		;strip ascii bits
	DCR	A		;make cpm drive
	STA	THISDR		;save fro error messgae
	ADD	A
	ADD	A
	ADD	A
	ADD	A		;shift 4 places
	STA	SDRIVE		;save drive code
	LXI	D,DUBMSG
	CALL	ENTRY		;ask about double sided drives
	CALL	INPUT
	CPI	'N'		;not using dub sided disks
	MVI	A,0
	STA	DUBSID
	JRZ	BGIN1		;doing single sided
	CMA
	STA	DUBSID		;doing doub. sided
	MVI	A,0E7H		;double sided code byte
	STA	SPBYTE+1	;modify byte in spfill routine.
BGIN1:	LXI	D,RDY		;print ready message.
	CALL	ENTRY
	CALL	INPUT
	MOV	B,A		;save a copy in reg b
	CPI	'A'		;doing all?
	MVI	A,77
	STA	LSTTRK+1
	JRZ	START		;go ahead and do it.
	MOV	A,B		;check for format of system
	CPI	'S'		;doing just system trks
	MVI	A,2
	STA	LSTTRK+1	;modify number of tracks
	JRZ	START
EXIT:	EI
	MVI	A,STPRAT	;restore drive
	OUT	DCOM
	CALL	RETNDR
	LSPD	OLDSTK		;recover cpm stack
	RET			;go back to operating system
;
RETNDR:	HLT			;wait till done
	JMPR	RETNDR		;loop and allow keyboard intrps
;
ENTRY:	MVI	C,9		;print buffer function
	JMP	BDOS
;
;input routine - get a character from keyboard
;
;enter:	none
;exit:	reg a = char from keyboard
;registers used: d,e h,l c
;
INPUT:	MVI	A,4		;reset buffer length
	LXI	H,0
	SHLD	KEYBUF+1	;clear buffer
	STA	KEYBUF
	LXI	D,KEYBUF	;point to buffer
	MVI	C,RCB		;read buffer function
	EI
	CALL	BDOS		;get character
	DI
	LDA	KEYBUF+2	;get the first char only
	CPI	'a'		;check for lower case
	RC
	CPI	'z'+1
	RNC
	ANI	5FH		;make into upper case
	RET
;
; restore drive to track 00
;
START:	LXI	D,CRLF		;print cr,lf on console
	CALL	ENTRY
	LDA	SDRIVE		;get the selected drive
	OUT	DCONT		;select it now
	CALL	RDYDRV		;check for drive ready
	MVI	A,RSTOR+STPRAT+HLAB	;restore head to trk 0
	OUT	DCOM		;issue home cmd
	IN	WAIT
	IN	DSTAT
	MVI	C,0		;set track number to 0
LSTTRK:	MVI	H,78		;set total tracks to 78
FORMAT:	CALL	SIDE0
	MVI	A,5		;retrys
	STA	ERRCNT		;save it
RFORMAT:CALL	NXTTRK		;format the disk
	CALL	READ		;test formatted track
	ORA	A		;read ok?
	JRZ	SIDE		;yes,	check for side 1
	LDA	ERRCNT		;error, decrease count
	DCR	A
	STA	ERRCNT
	JRNZ	RFORMAT		;reformat and check again
	LXI	D,DISKER	;point to error message
	CALL	ENTRY
	JMP	BGIN2		;exit and return to start.
;
SIDE:	LDA	DUBSID		;check if doing double sided
	ORA	A		;zero = single sided only
	JZ	NEWTRK		;do other side if <> 0
	CALL	SIDE1		;now do side 1
	MVI	A,5
	STA	ERRCNT
RFMAT:	CALL	NXTTRK
	CALL	READ		;check for disk errors
	ORA	A		;errors?
	JRNZ	TRKERR		;yes
NEWTRK:	INR	L		;bump track #
	DCR	H		;trk count =count -1
	JRZ	HOMED		;restore to track 0
	MVI	A,STEP+HLAB+STPRAT	;load step in
	OUT	DCOM   		;do it
	IN	WAIT
	IN	DSTAT
	JMPR	FORMAT		;format next track
;
HOMED:	MVI	A,RSTOR+STPRAT	;restore the drive to trk 0
	OUT	DCOM
	IN	WAIT
	IN	DSTAT
	JMP	BGIN1
;
TRKERR:	LDA	ERRCNT		;error, decrease count
	DCR	A
	STA	ERRCNT
	JRNZ	RFMAT		;reformat and check again
	LXI	D,DISKER	;point to error message
	CALL	ENTRY
	JMP	BGIN2		;exit to start
;
SIDE0:	LDA	SDRIVE
	ANI	10110000B	;select side 0
	JMPR	SIDSEL
;
SIDE1:	LDA	SDRIVE
	ORI	01000000B	;select side 1
SIDSEL:	OUT	DCONT
	RET
;
NXTTRK:	LXI	D,1 SHL 8 OR 26 ;sector cnt to 0
	LXI	B,40 SHL 8 OR WAIT ;gap 4 preindex 40 bytes of ff
	MVI	A,0F4H		;load track write command
	OUT	DCOM		;issue track write
;
; write preindex fill
;
PREIND:	INP	A		;wait for drq
	JP	ERRMSG		;jmp out if error
	MVI	A,0FFH		;load preindex fill
	OUT	DDATA		;write it on disk
	DJNZ	PREIND		;go back till b =0
	MVI	B,6
PREIN1:	INP	A
	JP	ERRMSG
	XRA	A
	OUT	DDATA
	DJNZ	PREIN1
;
; write address mark on track
;
	MVI	A,0FCH		;load address mark
	OUT	DDATA		;write it on disk
;
; post index gap
;
	MVI	B,26		;set # of bytes
POSTID:	INP	A		;wait for drq
	JP	ERRMSG		;jmp out if error
	MVI	A,0FFH		;load fill data
	OUT	DDATA		;write it on disk
	DJNZ	POSTID		;if not 0 go back
;
; pre id section
;
	MVI	B,6		;get # of bytes
SECTOR:	INP	A		;wait for drq
	JP	ERRMSG		;jmp out if error
	XRA	A		;make a = 0
	OUT	DDATA  		;write it on track
	DJNZ	SECTOR 		;jmp back if not done
;
; write id address mark
;
	MVI	A,0FEH 		;get address mark
	OUT	DDATA  		;write it on disk
;
; write track number on disk
;
	INP	A   		;wait for drq
	JP	ERRMSG 		;jmp out if error
	MOV	A,L		;get track number
	OUT	DDATA  		;write it on disk
;
; write one byte of 00
;
	INP	A   		;wait for drq
	JP	ERRMSG 		;jmp out if error
	XRA	A		;set a to 0
	OUT	DDATA  		;write it on disk
;
; write sector # on disk
;
	INP	A   		;wait for drq
	JP	ERRMSG 		;jmp out if error
	MOV	A,D		;get sector #
	OUT	DDATA  		;write it on disk
;
; one more byte 0
;
	INP	A   		;wait for drq
	JP	ERRMSG 		;jmp out if error
	XRA	A		;set a to 00
	OUT	DDATA  		;write it on disk
	INR	D		;bump sect. #
;
; write 2 crc's on this sector
;
	INP	A   		;wait for drq
	JP	ERRMSG 		;jmp out if error
	MVI	A,0F7H 		;get crc pattern
	OUT	DDATA  		;write it on disk
;
; pre data 17 bytes ff's
;
	MVI	B,11   		;set count
PREDAT:	INP	A   		;wait for drq
	JP	ERRMSG 		;jmp out if error
	MVI	A,0FFH		;set a to ff
	OUT	DDATA  		;write it on disk
	DJNZ	PREDAT 		;go back if not done
	MVI	B,6
PREDA1:	INP	A
	JP	ERRMSG
	XRA	A
	OUT	DDATA
	DJNZ	PREDA1
;
; data address mark
;
	INP	A   		;wait for drq
	JP	ERRMSG 		;jmp out if error
	MVI	A,0FBH 		;get data address mark
	OUT	DDATA  		;write it on disk
;
; fill data field with e5
;
	MVI	B,126		;126 e5's
DFILL:	INP	A   		;wait for drq
	JP	ERRMSG 		;happens here by now
	MVI	A,0E5H
	OUT	DDATA  		;write it on disk
	DJNZ	DFILL  		;do till done
	MVI	B,2
SPFILL:	INP	A
	JP	ERRMSG
SPBYTE:	MVI	A,0E5H		;doub sided byte if set=e7h
	OUT	DDATA
	DJNZ	SPFILL
;
; write crc's
;
	INP	A   		;wait till drq
	JP	ERRMSG 		;jmp out if error
	MVI	A,0F7H 		;get crc byte
	OUT	DDATA  		;write it on disk
;
; end of sector fill
;
	DCR	E		;reduce sector count
	JRZ	ENDTRK		;if 0 do end of track rtn
	INP	A		;wait for drq
	JP	ERRMSG 		;jmp out if error
	MVI	A,0FFH		;get fill character
	OUT	DDATA  		;write it on disk
	JMP	POSTID-2	;go back for more
;
; do track & sector house keeping
;
ENDTRK:	MVI	A,0E5H
	STA	SPBYTE+1
ENDTK1:	INP	A   		;wait for drq or intrq
	JP	DONE   		;jmp out if error
	MVI	A,0FFH		;load a with ffh
	OUT	DDATA  		;write it on disk
	JMPR	ENDTK1 		;do until intrq
;
DONE:	IN	DSTAT		;check status
	ANI	0C1H		;check bits,7,6,1
	RZ			;return if no errors
;
;error routine
;
ERRMSG:	LXI	D,ERROR
	CALL	ENTRY
	LXI	SP,STACK	;reset local stack
	JMP	BGIN2		;restart program
;
;disk read test routine.
;checks disk for errors
;after track is formatted.
;
;entry:	none
;exit:	accum = 0 if formatted ok
;	accum = ff if more than 5 retrys
;
READ:	EXX			;save all regs
	LXI	D,READC SHL 8 OR 1 ;get read command
	LXI	B,26 SHL 8 OR WAIT ;read 26 sectors total
READL:	CALL	DSKSET		;set up disk command
	ORA	D		;or in read command
	OUT	DCOM		;send read command
RLOOP:	INP	A		;wait for intrq
	JP	RDONE		;read finished when positive
	IN	DDATA		;read a byte
	JMPR	RLOOP		;accum = infinate bit bucket
;
RDONE:	IN	DSTAT		;check status
	ANI	18H		;check crc and rnf bits only
	JRZ	RNXT		;if = 0, read next sector
	JMPR	REXIT		;return to format program
;
RNXT:	INR	E		;bump sector number
	DJNZ	READL		;more to read.
REXIT:	EXX
	RET			;return with error code.
;
DSKSET:	MVI	A,0D0H		;force intrp command
	OUT	DCOM
	MOV	A,E		;get sector number
	OUT	SECTP
	IN	DSTAT		;check head load bit
	ANI	20H
	MVI	A,0		;set head load bit
	RZ
	MVI	A,4
	RET
;
;check to see if selected drive is ready.
;this routine is used to check slim line drives also.
;
RDYDRV:	IN	DSTAT		;check status
	RLC			;is drive ready?
	RNC			;return if ready
;
;if drive not ready (probably slim line drive), seek to
;same track to start motor.
;
	IN	FTRK		;get present track number
	OUT	DDATA		;place into data reg
	MVI	A,00011001B	;seek to same track to start drive
	OUT	DCOM		;send it
	IN	WAIT		;wait till started
	IN	DSTAT		;clear status
;
	MVI	B,50		;set for 50 * (16 * 1 ms) time delay
DELAY:	MVI	A,16		;16 ms delay constant
	MVI	C,249		;1 ms constant (4 MHz cpu speed)
DLY1:	DCR	C		;decrease count
	JRNZ	DLY1		;loop till = 0
	DCR	A		;decrease count factor
	JRNZ	DLY1		;loop for 16 ms
	DCR	B		;800 ms loop
	JRZ	NOTRDY		;print which drive is not ready
	IN	DSTAT
	RLC
	RNC			;return if ready
	JMPR	DELAY		;check for 800 ms before giving up.
;
;drive has been found not ready at all.
;
NOTRDY:	LDA	THISDR		;get requested disk number
	ADI	'A'		;convert to CP/M drive number
	STA	NDSKR		;save for message
	LXI	D,NTRDYM	;point to not ready message
	CALL	ENTRY		;print it
;
;hang waiting for disk to come ready.
;
DRVRDY:	IN	DSTAT
	RLC
	JRC	DRVRDY		;loop till ready
	LXI	D,CRLF
	JMP	ENTRY		;do a cr,lf
;
NTRDYM:	DB	CR,LF,'\\\ERROR\\\ Drive '
NDSKR:	DB	' : is not READY.$'
;
	DS	42			;stack area
STACK:	DS	1			;internal stack
OLDSTK:	DS	2			;cpm stack saved here
KEYBUF:	DS	7			;function 10 buffer
THISDR:	DS	1			;current drive select code
SDRIVE:	DS	1			;drive select code
DUBSID:	DS	1			;0=single sided format
ERRCNT:	DS	1			;disk retrys
	END	BEGIN
