	TITLE	'Single Density Disk Test Program of 10-26-82'
;
IOBASE	EQU	80H		;i/o base address of cpz-48000
VN	EQU	23		;version number
DATE0	EQU	10		;month
DATE1	EQU	26		;day
YEAR	EQU	82		;year
HLAB	EQU	8		;no headload @ beginning of seek = 0.
STPRAT	EQU	1		;step rate
SEEKC	EQU	18H		;seek command with head load.
DISK	EQU	IOBASE+10H	;disk base address.
DCOM	EQU	DISK		;disk command port.
DSTAT	EQU	DISK		;disk status port.
TRACK	EQU	DISK+1		;disk track port.
SECTP	EQU	DISK+2		;disk sector port.
DDATA	EQU	DISK+3		;disk data port.
WAIT	EQU	IOBASE+53H	;disk wait port.
DCONT	EQU	IOBASE+52H	;disk control port.
TRACKS	EQU	77		;tracks per disk.
SECTS	EQU	26		;sectors per track.
CR	EQU	0DH
LF	EQU	0AH
DOS	EQU	5		;bdos entry point.
BDOS	EQU	DOS
CREAD	EQU	1		;code for console read.
CPB	EQU	9		;code for print buffer.
CSTAT	EQU	11		;code for status check.
DRINT	EQU	25		;code for drive interrogate.
;
	ORG	100H		;starting address.
BEGIN:	JMP	BGIN		;jump around messages
;
;
; messages.
;
NRMSG:	DB	'Not Ready $'
RNMSG:	DB	'Record Not Found $'
CRCMSG:	DB	'CRC $'
LDMSG:	DB	'Lost Data $'
BSYMSG:	DB	'Busy $'
ERRMSG:	DB	'ERROR. $'
HEMSG:	DB	CR,LF,'Home Error',CR,LF,'$'
RDMSG:	DB	CR,LF,'Read $'
SKMSG:	DB	CR,LF,'Seek $'
TSMSG:	DB	CR,LF,'Track  '
TRKM:	DB	0
TRKL:	DB	0
	DB	'   Sector  '
SECM:	DB	0
SECL:	DB	0
CRLF:	DB	CR,LF,'$'
OMSG:	DB	CR,LF,'I.C.M. Single Density Disktest Program'
	DB	CR,LF
	DB	'Version ',VN/10+'0','.'
	DB	VN MOD 10+'0',' of '
	DB	DATE0/10+'0',DATE0 MOD 10+'0','-',DATE1/10+'0'
	DB	DATE1 MOD 10+'0','-',YEAR/10+'0',YEAR MOD 10+'0'
	DB	'$'
;
SELMSG:	DB	CR,LF,LF,'Select Drive. (A/B/C/D or Q to quit) $'
REMSG:	DB	CR,LF,'How Many Retrys? (0-9) $'
STPMSG:	DB	CR,LF,'Select Step Rate.'
	DB	'(3ms = 0, 6ms = 1, 10ms = 2, 15ms = 3)? $'
LSMSG:	DB	CR,LF,'Full Track Seek? (Y/N) $'
RMSG:	DB	CR,LF,'To Start Test Type Return. $'
RECMSG:	DB	CR,LF
REC:	DB	'    '
	DB	'  Read Errors Detected.',CR,LF,'$'
AMSG:	DB	CR,LF,'Aborting Test.',CR,LF,'$'
;
BGIN:	LXI	H,OMSG		;get message address.
	CALL	CPRINT		;print message.
	LXI	H,SECNT
	LXI	D,SECNT+1
	LXI	B,(CPMS-SECNT)	;length
	MVI	M,0		;clear the storage area
	LDIR
	SSPD	CPMS		;save cp/m stack pointer
	LXI	SP,STACK	;load stack pointer.
	JMPR	SELR1A
;
SELR:	MVI	A,STPRAT
	OUT	DCOM		;restore the drive
	CALL	INTWAT		;wait till done
;
SELR1A:	LXI	H,SELMSG	;drive select message.
	CALL	CPRINT		;print message.
	CALL	CONIN		;read drive.
	ANI	5FH		;convert to upper case.
	CPI	'Q'		;want to quit?
	JZ	 EXITT		;yes
	CPI	'A'		;compare
	JRC	 SELR		;for
	CPI	'E'		;correct
	JRNC	SELR		;drive.
	STA	DRIVE		;save it.
RETR:	LXI	H,REMSG		;retry question.
	CALL	CPRINT		;print question.
	CALL	CONIN		;read retry count.
	CPI	'0'		;compare
	JRC	RETR		;for
	CPI	':'		;correct
	JRNC	RETR		;number.
	ANI	0FH		;mask out upper nybble.
	INR	A		;add one.
	STA	RTCNT		;stash it.
STPSET:	LXI	H,STPMSG	;step rate message.
	CALL	CPRINT		;print it.
	CALL	CONIN		;get character.
	CPI	'0'		;check limits
	JRC	STPSET		;to small
	CPI	'4'
	JRNC	STPSET
	CALL	SETSTP		;set step rate.
	LXI	H,LSMSG		;long seek question.
	CALL	CPRINT		;print it.
	CALL	CONIN		;read response.
	ANI	5FH		;make upper case.
	CPI	'Y'		;is it y? if so,
	LXI	H,LST		;set location lst to
	MVI	M,1		;one for long seek.
	JRZ	READY		;jump.
	MVI	M,0		;zero for sequential seek.
READY:	LXI	H,RMSG		;get message address.
	CALL	CPRINT		;print message.
	CALL	CONIN		;read return.
	CPI	CR		;compare for return.
	JRNZ	READY		;go back if not.
	LXI	H,CRLF		;output a return and
	CALL	CPRINT		;linefeed to crt.
	XRA	A		;set a = 0.
	STA	TRK		;track counter = 0.
	STA	BCDTRK		;bcd track counter = 0.
	STA	BCRETO		;bcd read errors = 0.
	STA	BCRETH		;bcreth = 0.
	STA	TLONTL		;read error flag = 0.
	STA	OTIT		;otit = 0.
	STA	OT		;ot = 0.
	INR	A		;set a = 1.
	STA	SECT		;sector counter = 1.
	STA	BCDSEC		;bcd sector counter = 1.
	MVI	A,TRACKS	;set a = tracks.
	STA	IT		;it = tracks.
	CALL	SELECT		;select drive.
	CALL	HOME		;restore.
	JMP	READFS		;start reading.
;
INRTRK:	CALL	CONST		;check console input status.
	LDA	LST		;check location lst
	DCR	A		;for long seek. if one,
	JZ	LSTRK		;do it. if not,
	LDA	TRK		;get present track number.
	INR	A		;increment track number.
	CPI	TRACKS		;if last track,
	JZ	FINIS		;jump to end routine.
	STA	TRK		;save new track number.
	CALL	SEEK		;move head to new track.
	LDA	BCDTRK		;get bcd track number.
	ADI	1		;add one to track count.
	DAA			;decimal adjust.
	STA	BCDTRK		;stash it.
	MVI	A,1		;set a = 1.
	STA	SECT		;sector = 1 for new track.
	STA	BCDSEC		;bcd sector number = 1.
READFS:	CALL	READ		;read first sector.
INRSEC:	LDA	SECT		;get present sector number.
	INR	A		;increment sector number.
	CPI	SECTS+1		;if last sector,
	JZ	INRTRK		;start new track. if not,
	STA	SECT		;save new sector number.
	ORA	A		;clear flags.
	LDA	BCDSEC		;get bcd sector number.
	ADI	1		;add one to sector count.
	DAA			;decimal adjust.
	STA	BCDSEC		;stash it.
	CALL	READ		;read new sector.
	JMPR	INRSEC		;read next sector.
;
LSTRK:	LDA	OTIT		;check to read outer or
	INR	A		;inner track. increment
	STA	OTIT		;otit.	save it.
	ANI	1		;if lsb is high,
	JNZ	ITRK		;read inner track.
	LDA	OT		;get outer track number.
	INR	A		;increment track.
	CPI	TRACKS		;if last track,
	JZ	FINIS		;do quit routine.
	STA	OT		;save it.
	STA	TRK		;put in track counter.
	CALL	SEEK		;move head to track.
	LDA	BCDTRK		;get bcd track number.
	ADI	1		;add one to track count.
	DAA			;decimal adjust.
	STA	BCDTRK		;save it.
	MVI	A,1		;set a = 1.
	STA	SECT		;sector = 1 for new track.
	STA	BCDSEC		;bcd sector = 1 for new track.
	JMP	READFS		;read new track.
;
ITRK:	LDA	TRK		;get track number.
	CPI	TRACKS/2+1	;if < halfway in,
	JRC	INMOST		;seek inside track.
	XRA	A		;set a = 0.
	STA	TRK		;put in track counter.
	CALL	SEEK		;move head to track 0.
	JMPR	LSTRK		;read next track.
;
INMOST:	MVI	A,TRACKS-1	;set a = tracks-1.
	STA	TRK		;put in track counter.
	CALL	SEEK		;move head to track.
	JMPR	LSTRK		;read next track.
;
ETS:	LDA	BCDTRK		;get bcd track number.
	RRC			;shift
	RRC			;right
	RRC			;four
	RRC			;bits.
	ANI	0FH		;mask off upper nybble.
	ADI	'0'		;add ascii for zero.
	CPI	'0'		;see if msd is zero.
	JRNZ	TLSD		;print it if not zero.
	MVI	A,20H		;do not print if zero.
TLSD:	STA	TRKM		;insert in buffer.
	LDA	BCDTRK		;get bcd track again.
	ANI	0FH		;mask off upper nybble.
	ADI	'0'		;add ascii for zero.
	STA	TRKL		;insert in buffer.
	LDA	BCDSEC		;get bcd sector number.
	RRC			;shift
	RRC			;right
	RRC			;four
	RRC			;bits.
	ANI	0FH		;mask off upper nybble.
	ADI	'0'		;add ascii for zero.
	CPI	'0'		;check for msd of zero.
	JRNZ	SLSD		;print it if not zero.
	MVI	A,20H		;do not print if zero.
SLSD:	STA	SECM		;insert in buffer.
	LDA	BCDSEC		;get bcd sector again.
	ANI	0FH		;look at lower nybble.
	ADI	'0'		;add 30 hex.
	STA	SECL		;insert in buffer.
	LXI	H,TSMSG		;get message address.
	CALL	CPRINT		;print it.
	LXI	H,TLONTL	;get tlontl address.
	MVI	M,55H		;set to 01010101.
	JMP	CONST		;check console status.
;
ECOUNT:	LDA	BCRETO		;get bcd read error count.
	ADI	1		;add one to read error count.
	DAA			;decimal adjust.
	STA	BCRETO		;save it.
	RNC			;skip if no carry.
	LDA	BCRETH		;get hundreds count.
	ADI	1		;add one to count.
	DAA			;decimal adjust.
	STA	BCRETH		;save it.
	RET			;return.
;
FINIS:	LXI	H,REC		;point to rec buffer.
	LDA	BCRETH		;get read error msd's.
	RRC			;shift
	RRC			;right
	RRC			;four
	RRC			;bits.
	ANI	0FH		;look at one digit.
	JRZ	RECK		;suppress leading zero.
	ADI	'0'		;add ascii for zero.
RECK:	MOV	M,A		;insert in buffer.
	LDA	BCRETH		;get msd's back.
	ANI	0FH		;mask.
	JRNZ	PECH		;print if not zero.
	CMP	M		;check for previous zero.
	JRZ	RECH		;yes, so don't print.
PECH:	ADI	'0'		;add ascii.
RECH:	INX	H		;point to next digit.
	MOV	M,A		;insert.
	LDA	BCRETO		;get read error lsd's.
	RRC			;shift
	RRC			;right
	RRC			;four
	RRC			;bits.
	ANI	0FH		;mask it off.
	JRNZ	PECT		;print if not zero.
	LDA	BCRETH		;look at msd's.
	ORA	A		;see if zero.
	JRZ	RECT		;if so, don't print.
	XRA	A		;clear a.
PECT:	ADI	'0'		;add ascii.
RECT:	INX	H		;increment pointer.
	MOV	M,A		;stash in buffer.
	LDA	BCRETO		;get back lsd's.
	ANI	0FH		;mask.
	ADI	'0'		;add ascii.
	INX	H		;point to last digit.
	MOV	M,A		;stash it.
	LXI	H,RECMSG	;get error message.
	CALL	CPRINT		;print it.
	JMP	SELR		;start again
;
EXITT:	CALL	INTDRN		;interrogate drive number.
	LSPD	CPMS		;get old
	RET			;go back to cpm.
;
CONST:	MVI	C,CSTAT		;set c for status check.
	CALL	DOS		;do it.
	ANI	1		;look at lsb.
	RZ			;return if zero.
CONIN:	MVI	C,CREAD		;set c for console read.
	CALL	DOS		;input character.
	CPI	3		;check for control c.
	RNZ			;return if not.
	LXI	H,AMSG		;point to message.
	CALL	CPRINT		;send it.
	JMP	SELR		;restart from start.
;
INTWAT:	HLT			;stall processor
	JMPR	INTWAT		;loop till disk intrp happens
;
CPRINT:	PUSH	D		;save d and e.
	XCHG			;message address in d and e.
	MVI	C,CPB		;set c for print buffer.
	CALL	DOS		;print console buffer.
	POP	D		;restore d and e.
	RET			;return from cprint.
;
INTDRN:	MVI	C,DRINT		;code for drive query.
	CALL	DOS		;get loged in drive.
	MOV	A,E		;put in a.
	JMP	SELD		;select it.
;
SELECT:	LDA	DRIVE		;get drive for test.
	SUI	'A'		;subtract ascii for a.
	STA	DISKNO		;save it.
SELD:	ADD	A		;put bits
	ADD	A		;one and two
	ADD	A		;at four
	ADD	A		;and five.
	OUT	DCONT		;select drive.
	STA	LATCH		;save code.
	RET			;return from select.
;
SETSTP:	LXI	H,STP+1		;point to seek byte.
	MVI	M,SEEKC		;set for fast step.
	CALL	POKE		;set seek command.
	LXI	H,HOM+1		;point to restore byte.
	MVI	M,HLAB		;set for fast step with headload.
POKE:	CPI	'0'		;is it an f?
	RZ			;return.
	INR	M		;set for medium step.
	CPI	'1'		;is it an m?
	RZ			;go back.
	INR	M		;set for slow step.
	CPI	'2'		;is it an s?
	RZ
	INR	M		;must want slowest rate
	RET			;return.
;
HOME:	CALL	RDYDRV		;check for drive ready
	PUSH	B		;save reg bc
	LXI	B,8000
HMLOP:	DCX	B
	MOV	A,B
	ORA	C
	JRNZ	HMLOP
	POP	B
HOM:	MVI	A,STPRAT	;restore command.
	OUT	DCOM		;send it.
	CALL	INTWAT		;wait for disk intrp
	MOV	B,A		;save it.
	ANI	4		;check for track 0.
	JRZ	RERR		;error if not track 0.
	MOV	A,B		;get status back.
	ANI	91H		;look at error bits.
	RZ			;return if no error.
RERR:	LXI	H,HEMSG		;point to message.
	CALL	CPRINT		;print it.
	JMP	SELR		;do it again.
;
; read the sector at sect, from the present track.
; use starting address at dib.
;
READ:	LDA	RTCNT		;get retry count.
	STA	ERCNT		;store in error ctr.
RRETRY:	LDA	SECT		;get sector number.
	OUT	SECTP		;set sector into 1793.
	LXI	B,80H SHL 8 OR WAIT
	CALL	HDLD
	ORA	B
	DI			;disable intrps
	OUT	DCOM		;send command to 1793.
RLOOP:	INP	A		;wait for drq or intrq.
	JP	RDDONE		;done if intrq.
	IN	DDATA		;read a data byte from disk.
	JMPR	RLOOP		;keep reading.
;
HDLD:	IN	DSTAT
	BIT	5,A
	MVI	A,0
	RZ
	MVI	A,4
	RET
;
RDDONE:	EI			;enable intrps
	LXI	H,TLONTL	;get tlontl address.
	MVI	M,0		;set to zero.
	IN	DSTAT		;read disk status.
	ANI	9DH		;look at error bits.
	RZ			;return if none.
	LXI	H,ERCNT		;get error count.
	DCR	M		;decrement count.
	JRNZ	RRETRY		;try to read again.
	MOV	D,A		;save error byte
	CALL	ECOUNT		;count an error.
	LXI	H,RDMSG		;print "read ".
ERMSG:	CALL	CPRINT		;print origin message.
	BIT	7,D		;if bit 7 high,
	LXI	H,NRMSG		;"not ready".
	CNZ	CPRINT
	BIT	4,D		;if bit 4 is high,
	LXI	H,RNMSG		;print "record not found"
	CNZ	CPRINT
	BIT	3,D		;if bit 3 is high,
	LXI	H,CRCMSG	;print "crc error".
	CNZ	CPRINT
	BIT	2,D		;if bit 2 is high,
	LXI	H,LDMSG		;print "lost data".
	CNZ	CPRINT
	BIT	0,D		;if bit 1 is high,
	LXI	H,BSYMSG	;print "busy".
	CNZ	CPRINT
	LXI	H,ERRMSG	;print "error."
	CALL	CPRINT
	JMP	ETS		;jump to error print routine.
;
; move the head to the track in register a.
;
SEEK:	PUSH	B		;save b&c.
	MOV	B,A		;save destination track.
	LDA	RTCNT		;get retry count.
SRETRY:	STA	SERCNT		;store in error counter.
	IN	TRACK		;read present track no.
	MOV	C,A		;save in c.
	CMP	B		;same as new track no.?
	MOV	A,B		;restore a from b.
	JRNZ	NOTHR		;jump if not there.
THERE:	POP	B		;restore b&c.
	ORA	A		;reset flags.
	RET			;return from seek.
;
NOTHR:	OUT	DDATA		;track to data register.
STP:	MVI	A,SEEKC		;seek command.
	OUT	DCOM		;issue seek command.
	CALL	INTWAT		;wait for disk intrp
	ANI	91H		;look at bits.
	JRZ	THERE		;ok if zero.
	PUSH	H		;save h&l.
	LXI	H,SECNT		;get adr of seek err ctr.
	INR	M		;one more seek error.
	POP	H		;restore h&l.
	LDA	ERCNT		;get error count.
	DCR	A		;decrement count.
	JRNZ	SRETRY		;retry seek.
	POP	B		;restore b&c.
	LXI	H,SKMSG		;print "seek ".
	IN	DSTAT		;read disk status.
	ANI	81H		;look at error bits.
	MOV	D,A		;put in reg d.
	JMP	ERMSG		;do error messages.
;
;check to see if selected drive is ready.
;this routine is used to check slim line drives also.
;
RDYDRV:	IN	DSTAT		;check status
	RLC			;is drive ready?
	RNC			;return if ready
;
;if drive not ready (probably slim line drive), seek to
;same track to start motor.
;
	IN	TRACK		;get present track number
	OUT	DDATA		;place into data reg
	MVI	A,00011001B	;seek to same track to start drive
	OUT	DCOM		;send it
	CALL	INTWAT		;wait for intrp
;
	MVI	B,50		;set for 50 * (16 * 1 ms) time delay
DELAY:	MVI	A,16		;16 ms delay constant
	MVI	C,249		;1 ms constant (4 MHz cpu speed)
DLY1:	DCR	C		;decrease count
	JRNZ	DLY1		;loop till = 0
	DCR	A		;decrease count factor
	JRNZ	DLY1		;loop for 16 ms
	DCR	B		;800 ms loop
	JRZ	NOTRDY		;print which drive is not ready
	IN	DSTAT
	RLC
	RNC			;return if ready
	JMPR	DELAY		;check for 800 ms before giving up.
;
;drive has been found not ready at all.
;
NOTRDY:	LDA	DRIVE		;get requested disk number
	STA	NDSKR		;save for message
	LXI	D,NTRDYM	;point to not ready message
	MVI	C,9
	CALL	BDOS		;print it
;
;hang waiting for disk to come ready.
;
DRVRDY:	IN	DSTAT
	RLC
	JRC	DRVRDY		;loop till ready
	LXI	D,CRLF
	MVI	C,9
	JMP	BDOS		;print cr,lf and return
;
NTRDYM:	DB	'\\\ERROR\\\ Drive '
NDSKR:	DB	' : is  not Ready.$'
;
SECNT:	DS	1		;seek error count.
BCRETH:	DS	1		;msd's of read error count.
BCRETO:	DS	1		;lsd's of read error count.
DRIVE:	DS	1		;drive.
LATCH:	DS	1		;latch code.
DISKNO:	DS	1		;disk number.
TRK:	DS	1		;track number.
SECT:	DS	1		;sector number.
BCDTRK:	DS	1		;track number in bcd.
BCDSEC:	DS	1		;sector number in bcd.
RTCNT:	DS	1		;retry count.
ERCNT:	DS	1		;error count for retries.
SERCNT:	DS	1		;seek retry counter.
TLONTL:	DS	1		;read error flag.
LST:	DS	1		;long seek flag.
OT:	DS	1		;lst outer track.
IT:	DS	1		;lst inner track.
OTIT:	DS	1		;otit.
CPMS:	DS	2		;old stack pointer.
	DS	32		;stack area.
STACK:	DS	1
	END	BEGIN
