	TITLE	'512  Byte Disk Format Program of 10-26-82'
;
;format program for the wd1793 fdisk controller
;interleaved sector version
;
;added double sided formatting
;added function 10 to keyboard
;added dma clear command
;added read after track write for error checking
;modified for z-80 code (must use mac or zasm to assemble)
;added time out check for slim line drives (ready check).
;
IOBASE	EQU	80H		;i/o base address of cpz-48000
TRUE	EQU	0FFFFH
FALSE	EQU	NOT TRUE
;
MAC	EQU	FALSE		;true if using mac to assemble
;
; ******* interleave select *******
;
ONE	EQU	FALSE		;skew of 1
TWO	EQU	FALSE		;skew of 2
THREE	EQU	FALSE		;skew of 3
FOUR	EQU	TRUE		;skew of 4
FIVE	EQU	FALSE		;skew of 5
SIX	EQU	FALSE		;skew of 6
SEVEN	EQU	FALSE		;skew of 7
EIGHT	EQU	FALSE		;skew of 8
;
CR	EQU	0DH		;carriage return
LF	EQU	0AH		;linefeed
BELL	EQU	07H		;bell code
BDOS	EQU	5		;bdos entry point
RCB	EQU	10		;read buffer function
SIDE0	EQU	10111000B	;side 0 select code
SIDE1	EQU	01000000B	;side 1 select code
DMAP	EQU	IOBASE+70H	;dma controller base addr.
CMD	EQU	IOBASE+10H	;base addr. for floppy
FTRK	EQU	CMD+1		;floppy track register
SECT	EQU	CMD+2		;floppy sector register
DAL	EQU	CMD+3		;floppy data register
WAIT	EQU	IOBASE+53H	;wait port
DCONT	EQU	IOBASE+52H	;disk control port
WTRACK	EQU	0F4H		;disk write track command
SEEK	EQU	1BH		;seek = 6ms
ADR2	EQU	DMAP+4		;dma controller addr. reg
WCT2	EQU	DMAP+5		; "	  "	word count
CMND	EQU	DMAP+8		; "	"	command reg
FMASK	EQU	DMAP+10		;mask register port
MODE	EQU	DMAP+11		;dma mode register
RESTORE EQU 	01		;6ms restore code
;
	IF	MAC
	MACLIB	Z80
	ENDIF
;
	ORG	100H
;
	JMP	START		;jump around messages
;
MSG1:	DB	CR,LF,'I.C.M. 512 x 16 Double Density Deblock'
	DB	CR,LF,'Format Program Ver 1.6 of 10-26-82',CR,LF,LF
	DB	'Formats:',CR,LF
	DB	'Track  0      = 26 , 128 byte sectors',CR,LF
	DB	'Tracks 1 - 76 = 16 , 512 Byte sectors'
CRLFM:	DB	CR,LF,'$'
MSG2:	DB	CR,LF,'Drive ? (A,B,C,D)  or Q to Quit $'
MSG2A:	DB	CR,LF,'Format System or All or Quit? (S,A, or Q)  $'
MSG2C:	DB	CR,LF,'Format double sided (Y or N)  $'
MSG3:	DB	CR,LF,BELL,'ERROR- Check for write protected disk',CR,LF
MSG3A:	DB	CR,LF,BELL,'ERROR- Disk Controller Format Problem.$'
BELMSG:	DB	BELL,'$'
FRDERR:	DB	BELL,CR,LF,'Track 0 format error, try another diskette.$'
;
START:	SSPD	OLDSTK		;save cpm stack
	LXI	SP,STACK	;setup	stack
	LXI	D,MSG1
	MVI	C,9
	CALL	BDOS		;sign on
	JMPR	COMPT1
;
COMPLT:	CALL	RETNDR		;restore drive
COMPT1:	LXI	H,CLATCH	;point to area to clear
	MVI	B,XFER-CLATCH	;length
	XRA	A		;clear accum
	CALL	PUT		;clear the area to zeros
	INR	A		;flag <> 0,= format all the disk
	STA	FLAG
	MVI	A,0DEH		;default byte = single sided
	STA	SIDB+1		;modify the code byte
DOAGN:	LXI	D,MSG2
	MVI	C,9
	CALL	BDOS
	CALL	INPUT
	CPI	'Q'		;quit?
	JRNZ	CHKDRV		;no, check for valid drive
WEXIT:	CALL	RETNDR		;restore drive to home
	LSPD	OLDSTK		;q was pushed, so exit to system
	RET
;
CHKDRV:	CPI	'A'		;check drive range
	JRC	DOAGN		;wrong drive selected
	CPI	'E'		;greater than drive d?
	JRNC	DOAGN		;jump if drive e or greater
	ANI	3		;make upper case
	DCR	A		;make cpm drive number
	STA	THISDR		;save for error message
	ADD	A
	ADD	A
	ADD	A
	ADD	A		;compute latch value for drive
	MOV	C,A		;save it in reg c
	LDA	CLATCH		;get clatch value
	ORA	C		;select the drive
	STA	CLATCH		;save drive code
	LXI	D,MSG2C		;format doub sided?
	MVI	C,9
	CALL	BDOS		;print it
	CALL	INPUT
	CPI	'Y'
	JRNZ	DSEL
	STA	SIDED		;flag = yes
	MVI	A,0DCH		;doub side byte code
	STA	SIDB+1		;modify it
DSEL:	LXI	D,MSG2A		;tracks to format message
	MVI	C,9
	CALL	BDOS
	CALL	INPUT
	CPI	'A'		;all tracks?
	JRZ	START1
	CPI	'S'		;system tracks?
	JRZ	SYSTEM
	CPI	'Q'		;quit?
	JRZ	WEXIT		;yes
	LXI	D,BELMSG	;ring the bell for error
	MVI	C,9
	CALL	BDOS
	JMPR	DSEL
;
;input routine - get a character from keyboard
;
;enter:	none
;exit:	reg a = char from keyboard
;	stored at seld
;registers used: d,e h,l c
;
INPUT:	MVI	A,3		;reset buffer length
	LXI	H,0
	SHLD	KEYBUF+1	;clear buffer
	STA	KEYBUF
	LXI	D,KEYBUF	;point to buffer
	MVI	C,RCB		;read buffer function
	CALL	BDOS		;get character
	LDA	KEYBUF+2	;get the first char only
	CPI	'a'		;check for lower case
	RC
	CPI	'z'+1
	RNC
	ANI	5FH		;make into upper case
	RET
;
RETNDR:	MVI	A,RESTORE	;restore the drive to trk 0
	OUT	CMD
	CALL	NOTRDY		;wait for disk to intrp
;
;allow controller to settle
;
	IN	CMD		;clear intrp
DLWT:	PUSH	B
	LXI	B,8000H
DLYWT1:	DCX	B
	MOV	A,B
	ORA	C
	JRNZ	DLYWT1
	POP	B
	RET
;
DSIDE0:	LDA	CLATCH		;get current latch code
	ANI	SIDE0		;force side 0 active
	JMP	SAVEL		;save it
;
DSIDE1:	LDA	CLATCH		;get current latch code
	ORI	SIDE1		;force side 1
SAVEL:	STA	CLATCH		;save it
	OUT	DCONT		;select side on drive
	RET
;
SYSTEM:	XRA	A
	STA	FLAG		;set system only
START1:	LDA	CLATCH		;get latch value
	OUT	DCONT		;select drive
	CALL	RDYDRV		;check for drive ready
	CALL	RETNDR		;restore drive to trk 00
	IN	CMD		;check for write protected disk
	BIT	6,A		;is the write protect bit set
	JNZ	WRTPRT		;show error
	MVI	D,0		;set for track 0
	MVI	E,1		;sector 1
	LXI	H,BUFF		;dma buffer
	MVI	A,0FFH
	MVI	B,40
	CALL	PUT
	XRA	A
	MVI	B,6
	CALL	PUT
	MVI	M,0FCH		;index mark
	INX	H
	MVI	B,26		;start gap 1
	MVI	A,0FFH
	CALL	PUT
SLOOP:	XRA	A		;sync field
	MVI	B,6
	CALL	PUT
	MVI	M,0FEH		;id mark
	INX	H
	MOV	M,D		;track
	INX	H
	MVI	M,0		;side 0
	INX	H
	MOV	M,E		;sector
	INX	H
	MVI	M,0		;sector size
	INX	H
	MVI	M,0F7H		;write crc for id field
	INX	H
	MVI	A,0FFH		;start gap 2
	MVI	B,11
	CALL	PUT
	MVI	B,6
	XRA	A		;sync field
	CALL	PUT
	MVI	M,0FBH
	INX	H
	MVI	A,0E5H
	MVI	B,128
	CALL	PUT 		;data 128 bytes
	MOV	A,E		;are we on sector 1
	CPI	1		;is it sector 1?
	JRNZ	NOT1		;no, skip special id byte
	PUSH	H		;yes, put in
	DCX	H
	DCX	H
SIDB:	MVI	M,0DEH		;'de' = doub. den 512 x 16
	POP	H
NOT1:	MVI	M,0F7H
	INX	H
	MVI	A,0FFH
	MVI	B,27
	CALL	PUT
	INR	E
	MOV	A,E
	CPI	27
	JRNZ	SLOOP
	MVI	C,3
SLOOP3:	MVI	B,0
	MVI	A,0FFH
	CALL	PUT
	DCR	C
	JRNZ	SLOOP3
	PUSH	B
	PUSH	D
	PUSH	H
	CALL	DMA		;write	the disk with dma
	POP	H
	POP	D
	POP	B
	IN	CMD		;get status
	ANI	087H
	JNZ	ERROR
	PUSH	D
	CALL	SDREAD
	POP	D
	LDA	SIDED		;doing doub sided?
	ORA	A		;= to 0?
	JRNZ	START2		;if not, we are doing d.s
	INR	D
	MOV	A,D
	OUT	DAL 		;tell	1791
	MVI	A,SEEK
	OUT	CMD
	CALL	NOTRDY
	JMPR	START3
;
;here starts the double density formatting
;
START2:	MVI	A,1		;doing trk 0 side 1 d.d.
	STA	SFLAG		;set the flag
START3:	LDA	CLATCH		;get the current latch condition
	ORI	8		;set bit 4 = 1 for doub. density
	STA	CLATCH		; and save it
	OUT	DCONT		;now set the hardware latch
	LXI	H,TABLE		;point to s.density table for trk 1
LOOP2:	SHLD	PTR		;reset table pointer
	MOV	E,M		;sector number.
	LXI	H,BUFF		;dma buffer
	MVI	B,80
	MVI	A,4EH		;start gap 1
	CALL	PUT
	CALL	PUTZERO		;sync field
	MVI	A,0F6H
	MVI	B,3
	CALL	PUT
	MVI	A,0FCH		;index mark
	MVI	B,1
	CALL	PUT
	MVI	A,4EH
	MVI	B,50
	CALL	PUT
;
LOOP:	CALL	PUTZERO		;sync field
	MVI	A,0F5H		;index address mark
	MVI	B,3
	CALL	PUT
	MVI	M,0FEH
	INX	H
	MOV	M,D		;track number
	INX	H
	MVI	M,0		;side 0
	INX	H
	MOV	M,E		;sector number
	INX	H
	MVI	M,2		;sector size (512 bytes)
	INX	H
	MVI	M,0F7H		;write crc code
	INX	H
	MVI	A,4EH		;start gap 2
	MVI	B,22
	CALL	PUT
	CALL	PUTZERO		;sync field
	MVI	A,0F5H		;data address marks
	MVI	B,3
	CALL	PUT
	MVI	M,0FBH
	INX	H
	MVI	A,0E5H
	MVI	B,00
	CALL	PUT 		;data = 256 bytes of e5
	MVI	B,00
	CALL	PUT		;data = 256 bytes of e5
	MVI	M,0F7H		;write crc for data field
	INX	H
	MVI	A,4EH
	MVI	B,54		;start gap 3 (inter-record gap)
	CALL	PUT
	CALL	NXTSEC
	JRNZ	LOOP
	MVI	C,5		;start gap 4
LOOP3:	MVI	B,0
	MVI	A,4EH
	CALL	PUT
	DCR	C
	JRNZ	LOOP3
	LDA	SIDED
	ORA	A
	JRZ	NTSID1
	CALL	DSIDE1
	PUSH	D
	PUSH	H
	PUSH	B
	CALL	DMA
	POP	B
	POP	H
	POP	D
	IN	CMD
	ANI	087H
	JNZ	ERROR
	PUSH	H
	PUSH	D
	CALL	DDREAD
	POP	D
	POP	H
	CALL	DSIDE0
	LDA	FLAG
	ORA	A
	JZ	COMPLT
	LDA	SFLAG		;doing trk 0 side 1?
	CPI	1		;if = 1 then yes.
	MVI	A,0		;reset the flag
	STA	SFLAG		;
	JRZ	S1DONE		;this special side done
NTSID1:	PUSH	D
	PUSH	H
	CALL	DMA
	POP	H
	POP	D
	IN	CMD		;get	status
	ANI	087H
	JNZ	ERROR
	PUSH	H
	PUSH	D
	CALL	DDREAD
	POP	D
	POP	H
	LDA	FLAG		;are we doing all the disk ?
	ORA	A		;yes if not = 0
	JRZ	FDONE		;no, just first 2 tracks if = 0
S1DONE:	INR	D
	MOV	A,D
	CPI	77		;last track?
	JZ	FDONE
	OUT	DAL
	MVI	A,SEEK
	OUT	CMD
	CALL	NOTRDY
	LXI	H,STABLE	;reset sector pointer
	JMP	LOOP2
;
FDONE:	CALL	DLWT
	JMP	COMPLT
;
;read single density track 0 side 0 for errors
;
SDREAD:	LDA	XFER		;using dma?
	ORA	A
	JRZ	RDSDDM		;yes, use dma for read
	MVI	B,26		;number of single density sects
	MVI	C,1		;starting sector number
	MVI	D,80H		;read command
SDRD:	MVI	A,0D0H		;send force intrp command
	OUT	CMD		;send it
	MOV	A,C		;get the sector to do
	OUT	SECT		;send to controller
	CALL	HDLD		;check for head loaded
	ORA	D		;get read command
	OUT	CMD		;send read command to floppy
SDLOP:	IN	WAIT		;wait for drq or intrq
	ORA	A		;set flags
	JP	RDDON		;exit if done
	IN	DAL		;read a byte
	JMPR	SDLOP		;just a bit bucket loop
;
RDDON:	IN	CMD		;check for errors
	ANI	9DH		;mask value
	JRNZ	HAVERR		;jump if error found of any kind
	INR	C		;bump sector number
	DJNZ	SDRD		;loop till all 26 sectors read
	XRA	A		;return no error flag
	RET			;return to caller
;
HDLD:	IN	CMD		;get status
	ANI	20H
	MVI	A,4
	RZ
	MVI	A,0
	RET
;
HAVERR:	LXI	D,FRDERR	;point to format read error
	MVI	C,9
	CALL	BDOS		;jump to bdos for print
	MVI	A,1		;return error code
	RET
;
RDSDDM:	RET
;
DDREAD:	RET
;
PUT:	MOV	M,A
	INX	H
	DJNZ	PUT
	RET
;
PUTZERO:MVI	B,12
	XRA	A
	JMP	PUT
;
WRTPRT:	LXI	D,MSG3		;point to write protect message
	MVI	C,9
	CALL	BDOS
	JMP	COMPLT
;
ERROR:	IN	CMD		;get status
	STA	ERRST		;save the error byte
	LXI	D,MSG3A
	MVI	C,9
	CALL	BDOS
	LDA	ERRST		;recover status byte
	BIT	0,A		;busy?
	JRZ	CHKDRQ
	LXI	D,BUSYM		;print the message
	MVI	C,9
	CALL	BDOS
CHKDRQ:	LDA	ERRST
	BIT	1,A		;drq pending?
	JRZ	CHKLD
	LXI	D,DRQM
	MVI	C,9
	CALL	BDOS
CHKLD:	LDA	ERRST		;lost data?
	BIT	2,A
	JRZ	CHKWFT
	LXI	D,LOSTM
	MVI	C,9
	CALL	BDOS
CHKWFT:	LDA	ERRST
	BIT	5,A		;write fault?
	JRZ	CHKBSY
	LXI	D,WRTFLT
	MVI	C,9
	CALL	BDOS
CHKBSY:	LDA	ERRST
	BIT	7,A		;drive not ready?
	JRZ	DONTNO
	LXI	D,NRDYM
	MVI	C,9
	CALL	BDOS
DONTNO:	LXI	D,CRLFM
	MVI	C,9
	CALL	BDOS
	JMP	COMPLT
;
BUSYM:	DB	CR,LF,'Floppy BUSY error.$'
DRQM:	DB	CR,LF,'Floppy DRQ Error.$'
LOSTM:	DB	CR,LF,'Floppy LOST DATA Error.$'
WRTFLT:	DB	CR,LF,'Floppy WRITE FAULT Error.$'
NRDYM:	DB	CR,LF,'Floppy NOT READY Error.$'
;
;dma routine
;
DMA:	PUSH	H		;save ending address
	LXI	H,BUFF		;point to format buffer
	MVI	A,0D0H		;send force intrp to floppy
	OUT	CMD
	MOV	A,L		;get low addr byte
	OUT	ADR2		;put it to dma controller
	MOV	A,H		;get high addr byte
	OUT	ADR2		;put it to controller
	POP	H		;restore ending address
	DCX	H		;set count -1 for length
	MOV	A,L		;get the low byte
	OUT	WCT2		;put it to controller
	MOV	A,H		;get high byte of count
	OUT	WCT2		;and put it to controller
	MVI	A,4AH		;dma write command
	OUT	MODE		;set the mode
	MVI	A,70H		;rotating priority
	OUT	CMND
	MVI	A,02H		;clear mask register for ch 2.
	OUT	FMASK
	MVI	A,WTRACK	;set for write track
	OUT	CMD		;tell 1791 about it
NOTRDY:	HLT			;wait for intrp
	JMPR	NOTRDY		;loop till intrp happens
;
NXTSEC:	PUSH	H
	LHLD	PTR
	INX	H		;bump pointer
	SHLD	PTR		;and get next byte
	MOV	E,M		;save sector number in reg e
	MOV	A,E		;check for end of table
	POP	H
	ORA	A		;set flags
	RET
;
;routine to check for drive ready (and slim lines)
;
;
;check to see if selected drive is ready.
;this routine is used to check slim line drives also.
;
RDYDRV:	IN	CMD		;check status
	RLC			;is drive ready?
	RNC			;return if ready
;
;if drive not ready (probably slim line drive), seek to
;same track to start motor.
;
	IN	FTRK		;get present track number
	OUT	DAL		;place into data reg
	MVI	A,00011001B	;seek to same track to start drive
	OUT	CMD		;send it
	CALL	NOTRDY		;wait for intrp
;
;delay for slim line drives to come ready.
;
	MVI	B,50		;set for 50 * (16 * 1 ms) time delay
DELAY:	MVI	A,16		;16 ms delay constant
	MVI	C,249		;1 ms constant (4 MHz cpu speed)
DLY1:	DCR	C		;decrease count
	JRNZ	DLY1		;loop till = 0
	DCR	A		;decrease count factor
	JRNZ	DLY1		;loop for 16 ms
	DCR	B		;800 ms loop
	JRZ	DNTRDY		;print which drive is not ready
	IN	CMD
	RLC
	RNC			;return if ready
	JMPR	DELAY		;check for 800 ms before giving up.
;
;drive has been found not ready at all.
;
DNTRDY:	LDA	THISDR		;get requested disk number
	ADI	'A'		;convert to CP/M drive number
	STA	NDSKR		;save for message
	LXI	D,NTRDYM	;point to not ready message
	MVI	C,9
	CALL	BDOS		;print it
;
;hang waiting for disk to come ready.
;
DRVRDY:	IN	CMD		;check status again
	RLC
	JRC	DRVRDY		;loop till ready
	RET
;
NTRDYM:	DB	CR,LF,7,'```E R R O R``` Drive '
NDSKR:	DB	' : is NOT ready.$'
;
FLAG:	DB	0
PTR:	DW	TABLE
;
;table for 512 x 16 sectors
;
TABLE:	DB	1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16
	DB	0
;
STABLE:
	IF	ONE
	DB	1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16
	ENDIF

	IF	TWO			;if skew equals 4
	DB	1,3,5,7,9,11,13,15,2,4,6,8,10,12,14,16
	ENDIF

	IF	THREE
	DB	1,4,7,10,13,16,2,5,8,11,14,3,6,9,12,15
	ENDIF

	IF	FOUR
	DB	1,5,9,13,2,6,10,14,3,7,11,15,4,8,12,16
	ENDIF

	IF	FIVE
	DB	1,6,11,16,2,7,12,3,8,13,4,9,14,5,10,15
	ENDIF

	IF	SIX
	DB	1,7,13,2,8,14,3,9,15,4,10,16,5,11,6,12
	ENDIF

	IF	SEVEN
	DB	1,8,15,2,9,16,3,10,4,11,5,12,6,13,7,14
	ENDIF

	IF	EIGHT
	DB	1,9,2,10,3,11,4,12,5,13,6,14,7,15,8,16
	ENDIF

	DB	00		;terminator byte
;
;storage area
;
CLATCH:	DB	0		;current hardware latch value
ERRST:	DB	0		;error status save
SFLAG:	DB	0		;if 1, doing trk 0 side 1 doub den
SIDED:	DB	0		;0= sing.sided, <> 0 = doub.sided
XFER:	DB	0		;type xfer flag byte
	DS	20		;stack area
STACK:	DS	1
OLDSTK:	DS	2		;cpm stack save
THISDR:	DS	1		;current physical drive select
KEYBUF:	DS	6
BUFF:	DS	1		;format buffer
	END	START

