	TITLE	'I.C.M. Turbo-Disk of 11-02-82'
;
;	\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
;	\\        ***  T U R B O - D I S K  ***       \\
;	\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
;
;----------------------------------------------------------------+
; This program must be assembled using MAC from Digital Research |
;----------------------------------------------------------------+
;
TRUE	EQU	0FFFFH		;define true
FALSE	EQU	00000H		;define false
;
;""""""""   This is the area you change for your situation   """""""""""|
;           ----------------------------------------------		|
CPMSIZ	EQU	63	;cp/m memory size in kilobytes.			|
IOBASE	EQU	80H	;i/o  base address of cpz-48000.		|
BELERR	EQU	TRUE	;true if want bell to ring on errors.		|
KEYINT	EQU	FALSE	;true if using keyboard intrps on input.	|
BUFLEN	EQU	24	;type ahead buffer size	if using KEYINT.	|
UNDER	EQU	FALSE	;true if RUBOUT key changed to UNDERLINE.	|
MTOM	EQU	FALSE	;true if using mem. to mem. dma xfer.		|
TURBO	EQU	FALSE	;true if using turbo option.			|
MEMBNK	EQU	4	;number of 64k banks in system (for TURBO).	|
MDIRS	EQU	064	;number of turbo directory entries.		|
NFLOPS	EQU	2	;number of floppys physically on system.	|
PERSCI	EQU	FALSE	;true if using persci drives.			|
AUTDRV	EQU	TRUE	;true if using cross drive auto select.		|
SERPNT	EQU	FALSE	;true if using serial printer, else parallel.	|
TIMER	EQU	FALSE	;true if using data/time function.		|
AUTOTIM	EQU	FALSE	;true if auto time set wanted.			|
SLORST	EQU	1	;0=no slow restore, 1=slow restore of drive.	|
HLABSK	EQU	8	;8=head load at beginning of seek.		|
ERRCNT	EQU	10	;error retry count.				|
;									|
;""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
;
	IF	TIMER
TIME	EQU	8	;memory location for start of time data
YEAR	EQU	TIME+0	;year byte
MONTH	EQU	TIME+1	;month byte
DAY	EQU	TIME+2	;day byte
HOUR	EQU	TIME+3	;hour byte
MINS	EQU	TIME+4	;minute byte
SECS	EQU	TIME+5	;second byte
TSECS	EQU	TIME+6	;tenths of seconds byte
	ENDIF
;
	MACLIB	Z80	;use macro library
	MACLIB	IOEQU	;use macro library for icm i/o
;
;this describes the size of the turbo in Kbytes
;
	IF	TURBO
MDSKN	EQU	NFLOPS	;define turbo-disk binary number
SIZBLK	EQU	2048	;turbo block size (2k blocks for TURBO)
MDSIZ	EQU	(MEMBNK * 64)/(SIZBLK/1024)
	MACLIB	TURBO	;use turbo software library
	MACLIB	DISKDEF	;use diskdef lib for turbo
	ENDIF
;
BIAS	EQU	(CPMSIZ-20)*1024
CCP	EQU	3400H+BIAS	;base of ccp
BDOS	EQU	CCP+806H	;base of bdos
BIOS	EQU	CCP+1600H	;base of bios
WBSECTS	EQU	17		;warm start sector count
IOBYTE	EQU	3		;intel i/o byte
AUTOCCP	EQU	CCP+7		;auto load patch point
CR	EQU	0DH
LF	EQU	0AH
;
	IF	TURBO
NDISK	EQU	NFLOPS+1	;number of drives on system
	ELSE
NDISK	EQU	NFLOPS		; # of floppys
	ENDIF
;
FLPYRD	EQU	10000000B	;floppy read command
FLPYWT	EQU	10100000B	;floppy write command
FLPYID	EQU	11000000B	;read id command
BLK128	EQU	128		;sgl / dbl den. sect size
BLK512	EQU	512		;deblock sector size
;
;cp/m to host disk constants
;
BLKSIZ	EQU	2048		;cp/m allocation size
HSTSIZ	EQU	512		;host disk sector size
HSTSPT	EQU	16		;host disk sectors/trk
HSTBLK	EQU	HSTSIZ/128	;cp/m sects/host buff
CPMSPT	EQU	HSTBLK * HSTSPT	;cp/m sectors/track
SECMSK	EQU	HSTBLK-1	;sector mask
;
	IF	TURBO
	MDCPMC			;track / sector constants
	ENDIF
;
;bdos constants on entry to write
;
WRDIR	EQU	1		;write to directory
WRUAL	EQU	2		;write to unallocated
;
;this patch will allow the user to set the date and
;time when ever the system is first loaded from a
;coldstart.
;
	IF	AUTOTIM
	ORG	AUTOCCP
	DB	7		;length of message
	DB	'SETTIME'	;file to load
	DB	0		;terminator byte
	ENDIF
;
;auto drive default search routine.
;will search drive a: for file not
;found on current logged drive. (com type)
;
	IF	AUTDRV		;if using cross drive select
	ORG	CCP+0D7H
	JMP	AUTSEL
	ENDIF
;
;patch cpm 2.2 with overlay for deblock operation (D.R. Patch)
;
	ORG	CCP+12D2H
	NOP
	NOP
	LXI	H,0
;
;------------- start of bios ----------------------------------
;
	ORG	BIOS		;origin of this program
;
;	jump vector for individual subroutines
;
CBOOTE:	JMP	BOOT		;cold start
WBOOTE:	JMP	WBOOT		;warm start
	JMP	CONST		;console status
	JMP	CONIN		;console character in
	JMP	CONOUT		;console character out
	JMP	LIST		;list character out
	JMP	PUNCH		;punch character out
	JMP	READER		;reader character out
	JMP	HOME		;move head to home
	JMP	SELDSK		;select disk
	JMP	SETTRK		;set track number
	JMP	SETSEC		;set sector number
	JMP	SETDMA		;set dma address
	JMP	READ		;read disk
	JMP	WRITE		;write disk
	JMP	LISTST		;return list status
	JMP	SECTRA		;sector translate
;
;auto cross drive select routine
;
	IF	AUTDRV		;if using auto cross drive
AUTSEL:	PUSH	D
	CALL	CCP+0CBH
	POP	D
	RNZ
	MVI	A,1
	STAX	D
	JMP	CCP+0CBH
	ENDIF
;
;	sector translate vector floppy disk
;
TRANS:	DB	1,7,13,19	;sectors 1,2,3,4
	DB	25,5,11,17	;sectors 5,6,7,8
	DB	23,3,9,15	;sectors 9,10,11,12
	DB	21,2,8,14	;sectors 13,14,15,16
	DB	20,26,6,12	;sectors 17,18,19,20
	DB	18,24,4,10	;sectors 21,22,23,24
	DB	16,22		;sectors 25,26
;
;	disk parameter block, single density
;
DPBLK1:	DW	26		;sectors per track
	DB	3		;block shift factor
	DB	7		;block mask
	DB	0		;null mask
	DW	242		;disk size-1
	DW	63		;directory max
	DB	192		;alloc 0
	DB	0		;alloc 1
	DW	16		;check size
	DW	2		;track offset
;
;defines a single density double sided disk
;
DPBLK2:	DW	26
	DB	4
	DB	15
	DB	1
	DW	242
	DW	127
	DB	192
	DB	0
	DW	32
	DW	2
;
;	double density disk parameter block
;
DPBLK3:	DW	64		;sectors per track
	DB	4		;block shift factor
	DB	15		;block mask
	DB	0		;null mask
	DW	299		;disk size-1
	DW	127		;directory max
	DB	192		;alloc 0
	DB	0		;alloc 1
	DW	32		;check size
	DW	2		;track offset
;
;defines a double density / double side 512 x 16
;
DPBLK4:	DW	64
	DB	5
	DB	31
	DB	1
	DW	303
	DW	255
	DB	192
	DB	0
	DW	64
	DW	2
;
;	end of fixed tables
;
	ORG	($+17) AND 0FFF0H	;place on even boundry
;
;the following table is for MODE 2 pointers
;
INTVEC	EQU	$		;mode 2 vector table start
;
	IF	TIMER		;if using date/time function
	DW	TIMINT		;(V1) or pointer to time intrp handler
	ELSE
	DW	DUMMY		;(V1) or pointer to dummy return
	ENDIF
;
	DW	DSKINT		;(V2) or pointer to disk intrp handler
	DW	DUMMY		;(V3) or pointer to dummy return
	DW	DUMMY		;(V4) or pointer to dummy return
	DW	DUMMY		;(V5) or pointer to dummy return
	DW	DUMMY		;(V6) or pointer to dummy return
	DW	DUMMY		;(V7) or pointer to dummy return
	DW	DUMMY		;(V8) or pointer to dummy return
;
	IF	KEYINT
INTKEY:	DW	KEYSVC		;pointer to keyboard service
	ENDIF
;
;disk interrupt handler routine
;
DSKINT:	IN	DSTAT		;get disk status and clr intrp
	INX	SP		;bump up to real return address
	INX	SP
DUMMY:	EI			;enable intrps again
	RET			; and return it to caller
;
;keyboard intrp service routine
;
	IF	KEYINT
KEYSVC:	PUSH	PSW
	PUSH	H		;save hl
	IN	DATAB		;read sio data port B
	LXI	H,COUNT		;point at char counter
	INR	M		;bump it
	LHLD	POINT1		;get pointer 1
	MOV	M,A		;save the character in buffer
	LDA	POS1		;get position counter
	DCR	A		;check for overflow
	JRZ	KEYSV2		;jump if buffer overflow
	INX	H		;bump pointer 1
KEYSV1:	STA	POS1		;save position 1
	SHLD	POINT1		;save pointer 1
	POP	H
	POP	PSW
	EI
	RETI
;
KEYSV2:	MVI	A,BUFLEN	;reset buffer length
	LXI	H,KEYBUF	;reset buffer pointer
	JMPR	KEYSV1		;set the values
;
;buffer constants
;
COUNT:	DB	0		;character counter
POINT1:	DW	KEYBUF		;pointer for key buffer
POS1:	DB	BUFLEN		;buffer length
POINT2:	DW	KEYBUF		;pointer for key buffer
POS2:	DB	BUFLEN		;buffer length
	ENDIF
;
	IF	TIMER		;if using time/date function
TIMINT:	PUSH	PSW		;save accum and flags
	PUSH	H		;save h,l
	LXI	H,TSECS		;point to tenths of seconds
	INR	M		;bump it
	MOV	A,M		;get it
	SUI	50		;top of second mark?
	JRNZ	TIMXIT		;exit if not
	CALL	TSET		;advance to next second
	SUI	60		;top of minute mark?
	JRNZ	TIMXIT		;exit if not
	CALL	TSET		;advance to next minute
	SUI	60		;top of min. mark?
	JRNZ	TIMXIT		;exit if not
	CALL	TSET		;advance to next hour
	SUI	24		;top of hour mark
	JRNZ	TIMXIT		;exit if not
	CALL	TSET		;advance to next day
TIMXIT:	POP	H
	POP	PSW		;world restored
	EI			;enable intrps
	RET			;return
;
TSET:	MOV	M,A
	DCX	H
	INR	M
	MOV	A,M
	RET
	ENDIF
;
;	fixed data tables for three-drive standard
;	ibm-compatible 8" disks
;	disk parameter header for disk 00
;
DPBAS1:	DW	TRANS,0000H
	DW	0000H,0000H
	DW	DIRBUF,DPBLK1
	DW	CHK00,ALL00
;
;	disk parameter header for disk 01
;
	IF	NFLOPS GE 2
	DW	TRANS,0000H
	DW	0000H,0000H
	DW	DIRBUF,DPBLK1
	DW	CHK01,ALL01
	ENDIF
;
;	disk parameter header for disk 02
;
	IF	NFLOPS GE 3
	DW	TRANS,0000H
	DW	0000H,0000H
	DW	DIRBUF,DPBLK1
	DW	CHK02,ALL02
	ENDIF
;
;	disk parameter header for disk 03
;
	IF	NFLOPS GE 4
	DW	TRANS,0000H
	DW	0000H,0000H
	DW	DIRBUF,DPBLK1
	DW	CHK03,ALL03
	ENDIF
;
	IF	TURBO
	MDHEDER			;define turbo header
	ENDIF
;
;print message until zero terminator
;
PRNTM:	MOV	C,M		;get a byte
	RES	7,C		;kill parity bit
	CALL	CONOUT		; on crt
	BIT	7,M		;terminator?
	RNZ			;return if yes
	INX	H
	JMPR	PRNTM		;loop till done.
;
;dma read / write routine
;
DMA:	OUTP	E		;reg c = wct2
	OUTP	D		;length count-1
	DCR	C		;reg c = adr2 
	OUTP	L
	OUTP	H		;address for dma set up
	MVI	A,CLRREQ+CHAN2	;request chan 2
	OUT	FMASK		;allow this channel to request
;
;check for head load bit on in 1793
;
	IN	DSTAT		;get status from 1793
	BIT	5,A		;check head load bit
	MVI	A,0		;get a zero
	JRZ	HDLD		;jump if not loaded
	MVI	A,4		;else, get head load bit
HDLD:	ORA	B		;add in command for floppy
	OUT	DCOM		;send it to floppy
;
;general purpose wait routine
;
IDLE:	HLT			;wait for disk to intrp
	JMPR	IDLE		;loop until disk intrp happens
;
;warm boot
;
WBOOT:	LXI	SP,80H		;set boot stack
	LDA	HSTWRT		;check for pending dir write
	ORA	A		;is buffer active
	CNZ	WRITEHST	;write it out if yes
	XRA	A		;get a zero
	MOV	L,A
	MOV	H,A		;drive a select code
	SHLD	HSTACT		;clear unacnt and hstact flags
	SHLD	TRKTAB		;clear track table
	SHLD	TRKTAB+2
	SHLD	LOGBYT		;clear log in vector
;
	IF	NFLOPS GE 2
	MVI	H,10H		;drive b select code
	SHLD	LOGBYT+2
	ENDIF
;
	IF	NFLOPS GE 3
	MVI	H,20H		;drive c select code
	SHLD	LOGBYT+4
	ENDIF
;
	IF	NFLOPS GE 4
	MVI	H,30H		;drive d select code
	SHLD	LOGBYT+6
	ENDIF
;
	MOV	C,A		;reg c = drive select a:
	CALL	SELDSK		;select drive 0	
	LXI	H,CCP		;cpm base
	LXI	B,WBSECTS SHL 8 OR 2 ;sectors to load
;
;read the ccp from track 0 into memory
;
RDBLK:	MOV	A,C
	OUT	SECTP		;set sector
	PUSH	B		;save sectors to load
	CALL	RDSET		;use common setup routine
	LXI	D,BLK128-1	;single density byte count
	CALL	DMA		;use dma routine
	INX	D		;bump address + 128
	DAD	D
	POP	B		;restore sectors to load
	INR	C		;next sector
	DJNZ	RDBLK		;ccp re-loaded into memory
;
	IF	AUTOTIM		;stop autoload after CCP loaded
	XRA	A		;get a zero
	STA	AUTOCCP		;remove autoload function
	ENDIF
;
GOCPM:	MVI	A,0C3H		;init jmp loc in page 0
	STA	0
	LXI	H,WBOOTE	;get warmboot entry
	SHLD	1		;save it
	STA	5		;save jump inst.
	LXI	H,BDOS		;point to bdos entry
	SHLD	6		;save it
	LXI	H,80H		;set dma address
	SHLD	DMAADD
	LDA	4		;restore user # and disk #
	MOV	C,A		;drive in c
	JMP	CCP		;jump to ccp
;
;--------------------------------
;	intel iobyte routines
;--------------------------------
;
CONST:	LDA	IOBYTE		;check iobyte function
	ANI	00000011B	;get the function
	JRZ	TTYST		;jump if tty wanted
	CPI	00000001B	;set flags
	JRZ	CRTST		;check crt status (DEFAULT)
	CPI	00000010B	;set flags
	JRZ	BATST		;check batch status
;
;user defined console #1 status routine goes here
;
	RET			;not used
;
;batch status routine goes here
;
BATST:	RET			;not used
;
;tty status routine goes here
;
TTYST:	RET
;
;crt status check routine
;
CRTST:
	IF	KEYINT
	LDA	COUNT		;any characters waiting?
	ANA	A		;set flags
;
	ELSE
;
	IN	STATB		;console status
	BIT	CKBR,A		;check data ready
	ENDIF
;
	MVI	A,0		;return it is ready
	RZ
	CMA			;ff = not ready
	RET
;
;**** iobyte console input section ****
;
CONIN:	LDA	IOBYTE		;get the function
	ANI	00000011B	;get device number
	JRZ	TTYIN		;input from tty
	CPI	00000001B	;set flags
	JRZ	CRTIN		;input from crt (DEFAULT)
	CPI	00000010B	;set flags
	JRZ	BATIN		;batch input
;
;user #1 crt input routine goes here
;
	RET
;
;batch input routine goes here
;
BATIN:	RET
;
;tty input routine goes here
;
TTYIN:	RET
;
;read a character from the console
;
CRTIN	EQU	$
;
	IF	KEYINT
	LDA	COUNT		;any chars waiting?
	ANA	A
	JRZ	CRTIN		;loop if not until intrp
	DCR	A		;decrease char count
	STA	COUNT		;save it
	LHLD	POINT2		;get pointer 2
	MOV	B,M		;get the char from buffer
	LDA	POS2
	DCR	A		;check for end of buffer
	JRZ	CONIN2		;jump if end of buffer (overflow)
	INX	H		;bump pointer, no overflow yet
CONIN1:	STA	POS2
	SHLD	POINT2		;save pointer 2
	EI			;enable intrps
	MOV	A,B
;
	ELSE
;
	IN	STATB		;check keyboard
	BIT	CKBR,A		;mask value
	JRZ	CONIN		;loop till ready
	IN	DATAB		;get the key
	ENDIF
;
	RES	7,A		;strip parity bit
;
	IF	UNDER
	CPI	7FH		;rubout
	RNZ			;return if not
	MVI	A,5FH		;else, get a underline
	ENDIF
;
	RET
;
	IF	KEYINT
CONIN2:	MVI	A,BUFLEN	;reset buffer size
	LXI	H,KEYBUF	;point to key buffer
	JMPR	CONIN1		;reset pointers
	ENDIF
;
;**** iobyte console output section ****
;
CONOUT:	LDA	IOBYTE		;get the function
	ANI	00000011B	;isolate device numbers
	JRZ	TTYOT		;jump if tty out
	CPI	00000001B	;set flags
	JRZ	CRTOT		;output to crt (DEFAULT)
	CPI	00000010B	;set flags
	JRZ	BATOT		;batch output
;
;output to user #1 device
;
	RET
;
;batch output routine goes here
;
BATOT:	RET
;
;tty out routine goes here
;
TTYOT:	RET
;
;character out to console
;
CRTOT:	IN	STATB		;check output status
	BIT	CPTR,A		;mask
	JRZ	CONOUT		;loop till not busy
	MOV	A,C		;get cpm character
	OUT	DATAB		;send to console
	RET
;
;**** iobyte list section ****
;
LIST:	LDA	IOBYTE		;get function
	ANI	11000000B	;get device number
	JRZ	TTYOT		;use tty output
	CPI	01000000B	;want crt out?
	JRZ	CRTOT		;use crt output for list
	CPI	10000000B	;want line printer?
	JRZ	LPTOT		;jump if yes (DEFAULT)
;
;user # 1 list device goes here
;
	RET
;
; write a character on listing device.
;
LPTOT:	CALL	LISSTAT			;check printer status
;
	IF	SERPNT			;if using serial printer
	JRZ	LPTOT			;loop if busy
	MOV	A,C			;get cpm character
	OUT	DATAA			;send to printer

	ELSE

	JRNZ	LPTOT			;loop if busy
	MOV	A,C			;get the char
	OUT	PDATA			;send data to parallel port
	ENDIF
;
	RET
;
;**** iobyte punch section ****
;
PUNCH:	LDA	IOBYTE		;get the function
	ANI	00110000B	;get device number
	JRZ	TTYOT		;use tty output
	CPI	00010000B	;set flags
	JRZ	PTPOT		;high speed punch (DEFAULT)
	CPI	00100000B	;set flags
	JRZ	UP1OT		;user punch # 1
;
;user #2 punch goes here
;
	RET
;
PTPOT:	RET			;not used in this release
;
UP1OT:	RET			;user #1 punch not used
;
;**** iobyte reader section ****
;
READER:	LDA	IOBYTE		;get function
	ANI	00001100B	;get device number
	JRZ	TTYIN		;use tty input
	CPI	00000100B	;set flags
	JRZ	PTRIN		;jump to reader input (DEFAULT)
	CPI	00001000B	;set flags
	JRZ	UR1IN		;jump to user # 1 reader input
;
;user # 2 input routine goes here
;
	RET
;
UR1IN:	RET
;
PTRIN:	MVI	A,1AH		;return eof char as
	RET			;reader is not implemented here
;
;test list status routine
;
LISTST:	CALL	LISSTAT		;check printer status
	MVI	A,0		;return status activity
;
	IF	SERPNT
	RZ

	ELSE

	RNZ
	ENDIF
;
	CMA
	RET
;
;list status port check
;
LISSTAT	EQU	$
;
	IF	SERPNT		;if using serial printer
	IN	STATA		;check printer status
	BIT	LRBIT,A		;mask

	ELSE

	IN	PDATB		;check printer status
	BIT	0,A		;check the busy bit
	ENDIF
;
	RET
;
; translate the sector given by bc using the
; translate table given by de
;
SECTRA:	MOV	L,C		;double density part
	MOV	H,B
;
	IF	TURBO
	LDA	SEKDSK		;check for turbo
	CPI	MDSKN		;is it?
	RNC			;return if yes
	ENDIF
;
	LDA	DISKHF
	CPI	3		;deblock sector?
	RZ
;
	XCHG			;single density xlat
	DAD	B
	MOV	L,M
	MVI	H,0
	RET
;
;home - restore to track 0 with head loaded
;
HOME:	LDA	HSTWRT		;check for pending write
	ORA	A
	JRNZ	HOME1
	STA	HSTACT		;host inactive
HOME1:	LXI	B,0		;restore
;
;settrk - select track 0 - 76
;
SETTRK:	SBCD	SEKTRK		;save track value
	RET
;
;seldsk
;always done prior to settrk,setsec
;
SELDSK:	MOV	A,C
	CPI	NDISK		;number of defined drives
	JRC	SELOK		;jump if in range
	XRA	A		;default to drive a:
	STA	4		;save drive select code
	JMP	WBOOT		;do warm and default to a:
;
SELOK:	STA	SEKDSK		;system disk select save
;
	IF	TURBO
	MSEL
	ENDIF
;
	ADD	A		;double for indexing
	MOV	C,A		;put into reg c
	MVI	B,0		;clear reg b
	LXI	H,LOGBYT	;point to disk log vector
	DAD	B		;get logon location
	MOV	A,M		;get format
	STA	DISKHF		;save it for system reference
;
; 0 = unlogged
; 1 = single density
; 3 = double density (16 secs - 512 b)
;
	INX	H		;get disk pointer address
	ORA	A		;logged on?
	MOV	A,M
	STA	DISKHS		;store selected disk wait port
	JNZ	LOGGED
	PUSH	H		;save disk pointer address
	OUT	DCONT		;at single density
	CALL	RDYDRV		;check for drive ready
	LDA	USRSTP
	ORI	HLABSK+SLORST	;get headload command
	OUT	DCOM		;send command
	CALL	IDLE		;wait for intrp
	MVI	A,1
	OUT	SECTP		;address sector 1
	LXI	H,DIRBUF
	CALL	READLS		;read a logical sector
;
	LDA	DIRBUF+7EH
;
	CPI	0DEH		;double density 16 secs of 512?
	JRZ	DD64
;
	CPI	0DCH		;512 x 16 doub sided?
	JRZ	DD642
;
	CPI	0E7H		;doub sided single density
	JRZ	SD2
;
	LXI	H,1 SHL 8 OR 0H	;format flag and density mask
	LXI	D,DPBLK1	;single density parm block
SD2A:	LXI	B,TRANS		;sector translate table
	JMPR	PUT
;
SD2:	LXI	H,1 SHL 8 OR 40H
	LXI	D,DPBLK2
	JMPR	SD2A
;
DD642:	LXI	H,3 SHL 8 OR 48H
	LXI	D,DPBLK4
	JMPR	PUT1
;
DD64:	LXI	H,3 SHL 8 OR 8H	; 64 logical secs (16 by 512)
	LXI	D,DPBLK3
PUT1:	LXI	B,0
PUT:	MOV	A,L		;disk density mask
	XTHL			; pointer to disk hardware
	ORA	M		;add in density mask
	MOV	M,A		;and save
	STA	DISKHS		; (value for selected disk)
	DCX	H		;back up to format address
	XTHL
	MOV	A,H		;format type
	POP	H
	MOV	M,A		;save type (0, 1, 2, 3)
	STA	DISKHF
	PUSH	B
	LDA	SEKDSK		;fix up dpbase tables
	ADD	A
	ADD	A
	ADD	A
	ADD	A	
	MOV	C,A
	MVI	B,0
	LXI	H,DPBAS1	; reference table for this disk
	DAD	B
	POP	B
	MOV	M,C		;copy translate table address
	INX	H
	MOV	M,B
	LXI	B,9
	DAD	B
	MOV	M,E		;copy parameter block address
	INX	H
	MOV	M,D

LOGGED:	LDA	DISKHS
	ANI	30H		;eliminate density from address
	MOV	E,A
	MVI	D,0
	LXI	H,DPBAS1
	DAD	D
	RET
;
;setsec - set sector from reg b,c
;
SETSEC:	SBCD	SEKSEC		;save the sector
	RET
;
;setdma - set dma address from bc
;
SETDMA:	SBCD	DMAADD		;bc to dmaadr
	RET
;
;setup routine for read,write physical sectors
;
PHSET:	LDA	SEKSEC
	MOV	D,A
	LDA	DISKHS
	MOV	E,A
	LDA	SEKTRK
	CALL	SEEKLS
	LHLD	DMAADD
	RET
;
;common read setup routine
;
RDSET:	MVI	A,SINGLE+WRTXFR+CHAN2
	OUT	MODE		;send mode byte
	MVI	A,DREQL+ROTPRI
	OUT	CMND		;send command
	LXI	B,FLPYRD SHL 8 OR WCT2
	RET
;
RWSET1:	LDA	DISKHF		;check if deblocking
	CPI	3		;if = 3, deblocking
	LXI	D,(BLK512-1)
	RNC			;we are deblocking
	LXI	D,(BLK128-1)
	RET
;
;read - read a sector
;
READ:	EQU	$
;
	IF	TURBO
	HCOND	SEKDSK,READB
	ENDIF
;
	LDA	SEKTRK		;bypass format 3 if track 0
	ORA	A
	JRZ	READ1
	LDA	DISKHF		;if format 3 then deblock
	CPI	3
	JZ	READB
READ1:	CALL	PHSET		;use common routine for setup
;
; -read logical sector- hl is dma address
;
READLS:	CALL	RDYDRV		;check for drive ready
	MVI	A,ERRCNT	;retry count
RRTRY:	STA	RTCNT		;save it
	CALL	RDSET		;use common setup routine
	CALL	RWSET1		;check for deblocking
	CALL	DMA		;use common read/write
	ANI	9DH		;check for errors during read
	RZ			;return if no read errors
;
	IF	BELERR
	MVI	C,07H		;bell code
	CALL	CONOUT		;send it
	ENDIF
;
	LDA	RTCNT		;get retry count
	DCR	A		;decrement it
	JRNZ	RRTRY		;retry again
	PUSH	H
	LXI	H,RDERR		;retry exausted, print message
	CALL	PRNTM
	LXI	H,WATMSG	;point to error wait message
	CALL	PRNTM		;print it
	POP	H		;recover h,l
	CALL	CONIN		;wait for response
	CPI	03H		;cntl c?
	JZ	WBOOT		;abort this operation
	JMPR	READLS		;else, try to read again
;
;write - write a sector from dmaadr
;
WRITE:	EQU	$
;
	IF	TURBO
	HCOND	SEKDSK,WRITEB
	ENDIF
;
	LDA	SEKTRK		;bypass format 3 if track 0
	ORA	A		;track = 0?
	JRZ	WRIT1		;if = must be track 0
	LDA	DISKHF		;if format 3 then deblock
	CPI	3
	JZ	WRITEB
WRIT1:	CALL	PHSET		;use common routine
;
;-write logical sector-  hl is dma address
;
WRITEL:	CALL	RDYDRV		;check for drive ready
	MVI	A,ERRCNT		;retry count
WRTRY:	STA	RTCNT		;save it
	MVI	A,SINGLE+RDXFR+CHAN2
	OUT	MODE
	MVI	A,DREQL+ROTPRI
	OUT	CMND
	CALL	RWSET1		;check for deblocked write
	LXI	B,FLPYWT SHL 8 OR WCT2
	CALL	DMA		;use common read/write
	ANI	0FDH		;check for errors during read
	RZ			;return if no write errors
;
	IF	BELERR
	MVI	C,07H		;bell code
	CALL	CONOUT		;send it
	ENDIF
;
	LDA	RTCNT		;get retry count
	DCR	A		;decrement it
	JRNZ	WRTRY		;retry again
	PUSH	H
	LXI	H,WERR		;retry exausted, print message
	CALL	PRNTM
	LXI	H,WATMSG	;point to error wait message
	CALL	PRNTM		;print it
	POP	H		;recover h,l
	CALL	CONIN		;wait for response
	CPI	03H		;cntl c?
	JZ	WBOOT		;abort this operation
	JMPR	WRITEL		;else, try to write again
;
;check to see if selected drive is ready.
;this routine is used to check slim line drives also.
;
RDYDRV:	IN	DSTAT		;check status
	RLC			;is drive ready?
	RNC			;return if ready
;
;if not ready, seek to same track to start slim line drive,
;delay 16 ms, check drive for ready, try 50 times,
;if not ready after 50 times, error out.
;
	IN	TRACK		;get track number
	OUT	DDATA		;place into data  reg
	MVI	A,00011001B	;seek to same track with head load
	OUT	DCOM		; to start slim line drives
	CALL	IDLE		;wait for intrp
	MVI	B,70		;set for 70 * (16 * 1 ms) time delay
DELAY:	MVI	A,16		;16 ms delay constant
DELY1:	MVI	C,249		;1 ms constant (4 MHz cpu speed)
DLY1:	DCR	C		;decrease count
	JRNZ	DLY1		;loop till = 0
	DCR	A		;decrease count factor
	JRNZ	DLY1		;loop for 16 ms
	DCR	B		;1120 ms loop
	JRZ	NOTRDY		;print which drive is not ready
	IN	DSTAT
	RLC
	RNC			;return if ready
	JMPR	DELAY		;check for 1120 ms before giving up.
;
;drive has been found not ready at all.
;
NOTRDY:	PUSH	H		;save hl
	LDA	SEKDSK		;get requested disk number
	ADI	'A'		;convert to CP/M drive number
	STA	NDSKR		;save for message
	LXI	H,NTRDYM	;point to not ready message
	CALL	PRNTM		;print it
	POP	H		;recover hl
;
;hang waiting for disk to come ready.
;
DRVRDY:	IN	DSTAT
	RLC
	JRC	DRVRDY		;loop till ready
	RET
;
;logical sector seek
;
; A = track, E = drive #, density and side
; D = sector to read
;
SEEKLS:	PUSH	PSW		;save the track number
	LXI	H,OLDDSK	;point to last drive used
	MOV	A,M		;get it
	CMP	E		;current drv = last drv?
	MOV	M,E		;save this drive
	DCX	H		;point to flag
	MVI	M,0		;place a 0 if same drive
	JRZ	SEKSAM		;and seek to it
	INR	M		;else, not same drive, set flag
SEKSAM:	CALL	GETTRK		;save and restore track register
	MOV	A,M		;get track value
	OUT	TRACK		;force into 1793 track reg.
	POP	PSW		;restore track value
	CPI	1
	MOV	C,A		;save track in reg c
	MOV	A,E		;get copy of drive and density
	JRNC	SEEKOK		;we are > than track 1?
	ANI	30H		;clear density & side bit
	JMPR	SEEK2		;going to trk < 1
;
SEEKOK:	BIT	6,E		;doing doub sided?
	JRZ	SEEK3		;< > 1, doing single sided
	RRCR	C		;divide track by 2
	JRC	SEEKK1		;side bit set,doing odd trk
	RES	6,E		;reset side bit, doing even trk
SEEKK1:	RES	7,C		;clear msb of track value
SEEK3:	MVI	A,ERRCNT	;get retry count
SEEK1:	STA	SEEKRTY		;save it
	MOV	A,E		;get drive select code
SEEK2:	OUT	DCONT		;select disk and density
	PUSH	B		;save b,c
	CALL	RDYDRV		;check for drive ready
	POP	B
	CALL	DLYSEL		;delay on selects
	MOV	A,D		;get sector number
	OUT	SECTP		;tell the controoller chip
	IN	TRACK		;read 1793 track register
	CMP	C		;is track the same?
	JRZ	SAVTRK		;save track value for next time.
	MOV	A,C		;not same, get new track number
	OUT	DDATA		;seek to track with head load
;
;execute seek command
;
	LDA	USRSTP
	ORI	14H+HLABSK	;seek with head load
EXECC1:	OUT	DCOM		;output disk command
	CALL	IDLE		;wait for intrp
	ANI	10010001B	;mask out junk bits
	JRNZ	RIDCOM		;jump if error found
SAVTRK:	CALL	GETTRK		;save 1793 track register
	IN	TRACK		;get 1793 track
	MOV	M,A		;save in table
	RET
;
GETTRK:	MOV	A,E
	ANI	30H
	RRC
	RRC
	RRC
	RRC
;
	IF	PERSCI
	ANI	00001110B	;isolate l.s.b
	ENDIF
;
	MOV	C,A		;put disk number into reg e.
	MVI	B,0
	LXI	H,TRKTAB	;point to start of trk table
	DAD	B		;get correct drive byte
	RET
;
;we have an seek error,
;save primary registers
;and execute a read id.
;
RIDCOM:	PUSH	D
	CALL	RDSET		;use common setup routine
	LXI	H,BIOS-6	;buffer area for read id
	LXI	D,00005H	;dma read, length
	CALL	DMA		;read the id marks
	POP	D
	ANI	9DH		;any errors in reading?
	JRZ	DENOK		;no, density is correct.
	MOV	A,E		;get density and drive byte
	RES	3,A		;set single density for retry
	OUT	DCONT		;on read id.
	JMPR	RIDCOM		;switch registers and retry.
;
DENOK:	IN	SECTP		;get track byte
	OUT	TRACK		;place value into trk reg.
	LDA	SEEKRTY		;get retry count
	DCR	A
	JRNZ	SEEK1		;reseek to track
;
	LXI	H,SEEKER	;print error
	CALL	PRNTM		;print it
	JMP	WBOOT
;
;delay on new drive select
;
DLYSEL:	LXI	H,CHNGFL	;did we change drives?
	MOV	A,M
	ORA	A		;0=no, 1=yes
	RZ			;return if no
;
;drives are different, so get the
;present track number and seek to it
;to unload the head
;
	IN	TRACK		;get the present track number
	OUT	DDATA		;place into data register
	LDA	USRSTP		;get seek command
	ORI	10H		;seek to unload head
	OUT	DCOM		;send the command
	JMP	IDLE		;wait for intrp
;
;data tables
;
WATMSG:	DB	' Error, ^C to abort, CR to retr','y'+80H
RDERR:	DB	CR,LF,7,'Rea','d'+80H
WERR:	DB	CR,LF,7,'Writ','e'+80H
SEEKER:	DB	CR,LF,'*S','*'+80H
NTRDYM:	DB	CR,LF,7,'Drv '
NDSKR:	DB	' : not Rdy','.'+80H
;
;deblock write routine
;write the selected cp/m sector
;
WRITEB:	XRA	A		;0 to accumulator
	STA	READOP		;not a read operation
	MOV	A,C		;write type in c
	STA	WRTYPE
	CPI	WRUAL		;write unallocated?
	JRNZ	CHKUNA		;check for unalloc
;
;write to unallocated, set parameters
;
	IF	TURBO
	ALLCHK1	BLKSET
	ENDIF
;
	LDA	DISKHS		;check for double sided
	BIT	6,A		;if set, doing double sided
	MVI	A,BLKSIZ/128	;block size = 2048
	JRZ	BLKSET		;jump if single sided
	ADD	A		;block size = 4096
BLKSET:	STA	UNACNT		;save the alloc size
	LDA	SEKDSK		;get seek disk
	STA	UNADSK
	LHLD	SEKTRK
	SHLD	UNATRK
	LHLD	SEKSEC
	SHLD	UNASEC
;
;check for write to unallocated sector
;
CHKUNA:	LDA	UNACNT		;any unalloc remain?
	ORA	A
	JRZ	ALLOC		;skip if not
;
;more unallocated records remain
;
	DCR	A		;unacnt = unacnt-1
	STA	UNACNT
	LDA	SEKDSK		;same disk?
	LXI	H,UNADSK
	CMP	M		;sekdsk = unadsk?
	JRNZ	ALLOC		;skip if not
;
;disks are the same
;
	ORA	A		;clear flags
	LDED	UNATRK
	LHLD	SEKTRK
	DSBB	D		;sektrk = unatrk?
	JRNZ	ALLOC		;skip if not
;
;tracks are the same
;
	ORA	A		;clear flags
	LDED	SEKSEC		;same sector?
	LHLD	UNASEC
	DSBB	D		;seksec = unasec?
	JRNZ	ALLOC		;skip if not
;
;match, move to next sector for future ref
;
	IF	TURBO
	HALLOC	SEKDSK,NOHRD
	ENDIF
;
	LXI	B,CPMSPT	;get the number of cpm sectors
NOHRD:	LHLD	UNASEC		;get the sector
	INX	H		;increment it
	SHLD	UNASEC		;save it
	ORA	A		;clear flags
	DSBB	B		;have we exceeded the # of sects?
	JRNZ	NOOVF		;jump if not
	LXI	H,0		;else, max +1 has been reached
	SHLD	UNASEC		;reset the unalloc sectors
;
;overflow to next track
;
	LHLD	UNATRK
	INX	H
	SHLD	UNATRK		;unatrk = unatrk+1
;
;match found, mark as unnecessary read
;
NOOVF:	XRA	A		;0 to accumulator
	STA	RSFLAG		;rsflag = 0
	JMPR	RWOPER		;to perform the write
;
;deblock read routine
;read the selected cp/m sector
;
READB:	MVI	A,1
	STA	READOP		;read operation
	MVI	A,WRUAL
	STA	WRTYPE		;treat as unalloc
;
;not an unallocated record, requires pre-read
;
ALLOC:	XRA	A		;0 to accum
	STA	UNACNT		;unacnt = 0
	INR	A		;1 to accum
	STA	RSFLAG		;rsflag = 1
;
;common code for read and write follows
;enter here to perform the read/write
;
RWOPER:	XRA	A		;zero to accum
	STA	ERFLAG		;no errors (yet)
	LHLD	SEKSEC
	MOV	A,H		;rotate h,l right 2 places
	RRC			;move lsb of h into carry
	MOV	A,L
	RAR
	STC
	CMC
	RAR
	STA	SEKHST		;host sector to seek
;
;active host sector?
;
	LXI	H,HSTACT	;host active flag
	MOV	A,M
	MVI	M,1		;always becomes 1
	ORA	A		;was it already?
	JRZ	FILHST		;fill host if not
;
;host buffer active, same as seek buffer?
;
	LDA	SEKDSK		;get sekdsk
	LXI	H,HSTDSK	;same disk?
	CMP	M		;sekdsk = hstdsk?
	JRNZ	NOMATCH
;
;same disk, same track?
;
	ORA	A		;clear flags
	LDED	HSTTRK
	LHLD	SEKTRK
	DSBB	D		;sektrk = hsttrk?
	JRNZ	NOMATCH
;
;same disk, same track, same buffer?
;
	LDA	SEKHST
	LXI	H,HSTSEC	;sekhst = hstsec?
	CMP	M
	JRZ	MATCH		;skip if match
;
;proper disk, but not correct sector
;
NOMATCH:LDA	HSTWRT		;host written?
	ORA	A
	CNZ	WRITEHST	;clear host buff
;
;may have to fill the host buffer
;
FILHST:	LDA	SEKHST
	STA	HSTSEC		;destination for move
	LDA	SEKDSK
	STA	HSTDSK
	LHLD	SEKTRK
	SHLD	HSTTRK
	LDA	RSFLAG		;need to read?
	ORA	A
	CNZ	READHST		;yes, if 1
	XRA	A		;0 to accum
	STA	HSTWRT		;no pending write
;
;copy data to or from buffer
;
MATCH:	LDA	SEKSEC		;mask buffer number
	ANI	SECMSK		;least signif bits
	MOV	L,A		;ready to shift
	MVI	H,0		;double count
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	DAD	H
;
;hl has relative host buffer address
;
	LXI	D,HSTBUF
	DAD	D		;hl = host address
	LDED	DMAADD		;get/put cp/m data
	LDA	READOP		;which way?
	ORA	A
	JRNZ	RWMOVE		;skip if read
;
;write operation, mark and switch direction
;
	INR	A		;get a 1
	STA	HSTWRT		;hstwrt set to non-zero
	XCHG			;source/dest swap
;
;c initially 128, de is source, hl is dest
;
RWMOVE:
	IF	NOT MTOM	;if not using memory to memory
	LXI	B,128		;block move length
	LDIR			;fast z-80 block move
;
	ELSE
;
	CALL	MEMTOM		;use m/m dma xfer
	ENDIF
;
;data has been moved to/from host buffer
;
	LDA	WRTYPE		;write type
	CPI	WRDIR		;to directory?
	LDA	ERFLAG		;in case of errors
	RNZ			;no further processing
;
;clear host buffer for directory write
;
	ORA	A		;errors?
	RNZ			;skip if so
	XRA	A		;0 to accum
	STA	HSTWRT		;buffer written
	CALL	WRITEHST
	LDA	ERFLAG
	RET
;
;writehst performs the physical
;write to the host disk.
;hstdsk = host disk #, hsttrk = host track #,
;hstsec = host sect #. write "hstsiz" bytes
;from hstbuf and return error flag in erflag.
;return erflag non-zero if error
;
WRITEHST:
	CALL	SETIO		;set up to do write block
;
	IF	TURBO
	JNC	WRTHST		;write hardisk
	ENDIF
;
	CALL	WRITEL		;do it
	JMPR	XITIO
;
;readhst reads the physical disk.
;hstdsk = host disk #, hsttrk = host track #,
;hstsec = host sect #. read "hstsiz" bytes
;into hstbuf and return error flag in erflag.
;
READHST:
	CALL	SETIO		;get the selected disk parms
;
	IF	TURBO
	JNC	RDHST		;read hardisk
	ENDIF
;
	CALL	READLS		;read the selected disk
XITIO:	MVI	A,0		;0 = no error
	STA	ERFLAG		;save it
	RZ			;return if no errors
	CMA			;else,, we have an error
	STA	ERFLAG		;save the error flag byte
	RET

SETIO:	LXI	H,LOGBYT	;point to disk log table
	LDA	HSTDSK		;get selected disk
;
	IF	TURBO
	RWCON
	ENDIF
;
	ADD	A		;double for index
	MOV	E,A		;move into reg e
	MVI	D,0		;clear reg d
	DAD	D		;add to h,l
	INX	H		;bump to disk select code
	MOV	E,M		;disk sel stuff in reg e
	LDA	HSTSEC		;get the sector to do
	INR	A		;sector on disk is 1-16
	MOV	D,A		;save in reg d for seek
	LDA	HSTTRK		;get the track to do
	CALL	SEEKLS		;seek to track in reg a
	LXI	H,HSTBUF	;point to host buffer
;
	IF	TURBO
	XRA	A
	CMC
	ENDIF
;
	RET			;return to caller
;
;dma memory to memory transfer routine
;this is 3 times faster than z80 LDIR
;
;entry:	hl = source
;	de = destination
;    reg c = adr0 port
;	hl = 128-1 (after source is loaded)
;
	IF	MTOM
MEMTOM:	LXI	B,128-1
	SBCD	BLKMVS		;save the dma block size
MTOMSR:	MVI	A,SETREQ+CHAN0	;stop any action here
	OUT	FMASK
	INR	A		;stop chan 1 action here
	OUT	FMASK
	MVI	C,ADR0		;dma addr 0
	OUTP	L		;send low byte
	OUTP	H		;send high byte
	LHLD	BLKMVS		;get the block size
	INR	C		;bump to wct0
	OUTP	L		;send low byte length
	OUTP	H		;send high byte length
	INR	C		;bump to adr1
	OUTP	E		;send low byte of dest.
	OUTP	D		;send high byte of dest
	INR	C		;bump to wct1
	OUTP	L		;send low byte length
	OUTP	H		;word count = 128 - 1
	MVI	A,DREQL+ROTPRI+MTMENB	;set dreq low, m / m xfer
	OUT	CMND		;send it
	MVI	A,BLOCK+RDXFR+CHAN0
	OUT	MODE		;ch 0 = source (read from mem)
	MVI	A,BLOCK+WRTXFR+CHAN1
	OUT	MODE		;ch 1 = dest (write to mem)
	MVI	A,CLRREQ+CHAN0
	OUT	FMASK
	INR	A		;request chan 1
	OUT	FMASK		;clear chan 0 and chan 1 for req.
	MVI	A,SETREQ+CHAN0	;this causes the move to happen
	OUT	REQREG
MMDONE:	IN	CMND		;check for m/m done
	BIT	CH1TC,A		;is it active?
	JRZ	MMDONE		;loop till no more request
	ENDIF
;
;place dma into cascade mode for ch 0
;
CASMOD:	MVI	A,DREQL+ROTPRI
	OUT	CMND		;send it
	MVI	A,CASCADE+CHAN0
	OUT	MODE		;send it
	MVI	A,CLRREQ+CHAN0
	OUT	FMASK		;request chan 0
	RET
;
LOGBYT:	DW	0000H		;disk 0 log flag/den
;
	IF	NFLOPS GE 2
	DW	1000H		;disk 1 "
	ENDIF
;
	IF	NFLOPS GE 3
	DW	2000H		;disk 2 "
	ENDIF
;
	IF	NFLOPS GE 4
	DW	3000H		;disk 3 "
	ENDIF
;
	IF	TURBO
	MDSK			;turbo routines go here
	ENDIF
;
;the following area is claimed as the
;host buffer after system is running
;
HSTBUF	EQU	$		;host buffer
;
;hide system init in this area. we only
;use this stuff once
;
SIGNON:	DB	' ',CR,LF,'I.C.M '
	DB	CPMSIZ/10+'0',CPMSIZ MOD 10+'0'
	DB	'K CP/M 2.2 ver. Bios Dated 11-02-82.'
	DB	CR,LF,'I/O byte Implemented.'
;
	IF	SERPNT
	DB	CR,LF,'Serial Printer Option.'
	ELSE
	DB	CR,LF,'Parallel Printer Option.'
	ENDIF
;
	IF	KEYINT
	DB	CR,LF,BUFLEN/10+'0',BUFLEN MOD 10+'0'
	DB	' Char Keyboard Interrupt Version.'
	ENDIF
;
	IF	MTOM
	DB	CR,LF,'Memory-to-Memory Xfer Version.'
	ENDIF
;
	IF	TIMER
	DB	CR,LF,'Real Time Clock Version.'
	ENDIF
;
	DB	CR,LF,'Floppy Drives = A:'
;
	IF	NFLOPS GE 2
	DB	', B:'
	ENDIF
;
	IF	NFLOPS GE 3
	DB	', C:'
	ENDIF
;
	IF	NFLOPS GE 4
	DB	', D:'
	ENDIF
;
	IF	TURBO
	DB	CR,LF,'Turbo-Disk ver. of 02-28-82'
	ENDIF
;
	IF	TURBO
	DB	CR,LF,'Turbo-Disk = ','A'+MDSKN,':'
	ENDIF
;
	DB	80H		;terminator
;
;boot - cold start cp/m load
;
BOOT:	IN	DATAB		;clear console
	LDA	7FH		;get user step rate (in boot.asm)
	STA	USRSTP		;save for use in bios
	LDA	7DH		;get clear screen code (in boot.asm)
	STA	SIGNON		;save it for sign on message
	MVI	A,10010101B	;define default iobyte
	STA	IOBYTE		;set it
;
	IF	NOT SERPNT	;if using parallel port for printer
	MVI	A,00001111B	;set PIO chan A mode as output
	OUT	PCMDA		;send to command port
	MVI	A,11001111B	;set PIO chan B mode as mode 3
	OUT	PCMDB		;send the command
	MVI	A,11111111B	;define as input on all bits
	OUT	PCMDB		;send it
	MVI	A,00000111B	;we don't use intrps
	OUT	PCMDA		;set port A
	OUT	PCMDB		;and port B
	ENDIF
;
	XRA	A		;clear a
	MOV	L,A		;clear l
	MOV	H,A		;clear h
	STA	4		;set user/drive code for cpm
	SHLD	CBOOTE+1	;cant come here again
	LXI	H,DISKHF	;clear scratch area
	LXI	D,DISKHF+1	;block transfer dest.
	LXI	B,DMAADD-DISKHF+1	;count
	MOV	M,A		;set first loc. = 0
	LDIR			;use block move to clear
;
;init interrupt controller
;
	OUT	INTCMD		;reset intrp chip
	MVI	A,10000001B	;select mode reg, set bit 7
	OUT	INTCMD
	MVI	A,10110000B	;preselect mask command
	OUT	INTCMD
	MVI	A,11111100B	;un-mask timer and floppy intrps
	OUT	INTDOT
	MVI	A,11000000B	;select ACR register
	OUT	INTCMD
	MVI	A,00000011B	;set timer and floppy for auto-clear
	OUT	INTDOT
;
	LXI	H,INTVEC	;point to service routine
	MOV	A,H		;get high byte
	STAI			;set the interrupt register
	LXI	B,8 SHL 8 OR 0E0H ;number of vects and port
;
;fill 9519A response memory
;
I9519A:	MOV	A,C		;get response port
	OUT	INTCMD
	MOV	A,L		;get low memory byte
	OUT	INTDOT
	INR	L		;bump
	INR	L		;memory low byte pointer
	INR	C		;point to next response port
	DJNZ	I9519A		;loop till done
;
	MVI	A,01000000B	;clear irr bits
	OUT	INTCMD
	MVI	A,01110000B	;clear isr bits
	OUT	INTCMD
	MVI	A,10101001B	;clr mstr mask preselect irr
	OUT	INTCMD
	IM2			;set for interrupt mode 2
;
	IF	KEYINT
	LXI	H,INTKEY	;address of keyboard intrp pointer
	MOV	A,L		;get low byte
	STA	ILOC		;save if for sio register
	LXI	H,SIOTAB	;point to sio init table
	LXI	B,(SIOTABE-SIOTAB) SHL 8 OR COMB ;length and port
	OUTIR			;send init bytes to port B
	ENDIF
;
;start channel 2 of timer chip running
;
	IF	TIMER
	LXI	H,TIME
	LXI	D,TIME+1
	LXI	B,7		;count
	MVI	M,0
	LDIR			;block fill time area
	LXI	B,40000		;20 ms time constant
	MVI	A,CNTR2+RLWORD+BINARY+MODE2
	OUT	TCMND		;send init command to chan 2 of timer
	MOV	A,C
	OUT	TCH2		;send low byte
	MOV	A,B
	OUT	TCH2		;send high byte
	ENDIF
;
	CALL	CASMOD		;place system into cascade mode
;
	IF	TURBO
	MDINIT
	ENDIF
;
	LXI	H,SIGNON	;signon message
	CALL	PRNTM		;print it
	IN	DSTAT		;clear any pending intrps
	EI			;enable interrupts
	JMP	GOCPM		;set up low memory
;
	IF	KEYINT
SIOTAB:	DB	RSTCHAN,			REG4+RSTEXTI
	DB	X16CLK+STOP2,			REG3+RSTEXTI
	DB	RX8BITS+AUTENB+RXENBLE,		REG5+RSTEXTI
	DB	DTR+RTS+TX8BITS+TXENBLE,	REG2+RSTEXTI
ILOC:	DB	0,				REG1+RSTEXTI
	DB	INTRXNP
SIOTABE	EQU	$
	ENDIF
;
	DS	HSTSIZ-($-HSTBUF)
;
;ram storage area
;
USRSTP:	DS	1		;user step rate from boot
DISKHF:	DS	1		;disk hardware format (1, 2, 3)
DISKHS:	DS	1		;disk/density setting = hardware
TRKTAB:	DS	4		;track table for 4 drives
;
	IF	NOT TURBO
DIRBUF:	DS	128		;scratch directory area
	ENDIF
;
ALL00:	DS	38		;allocation vector 0
CHK00:	DS	64		;check vector 0
;
	IF	NFLOPS GE 2
ALL01:	DS	38		;allocation vector 1
CHK01:	DS	64		;check vector 1
	ENDIF
;
	IF	NFLOPS GE 3
ALL02:	DS	38		;allocation vector 2
CHK02:	DS	64		;check vector 2
	ENDIF
;
	IF	NFLOPS GE 4
ALL03:	DS	38		;allocation vector 3
CHK03:	DS	64		;check vector 3
	ENDIF
;
SEKHST:	DS	1		;seek shr secshf
SEKDSK:	DS	1		;seek disk number
SEKTRK:	DS	2		;seek track number
SEKSEC:	DS	2		;seek sector number
;
UNADSK:	DS	1		;last unalloc disk
UNATRK:	DS	2		;last unalloc track
UNASEC:	DS	2		;last unalloc sector
;
HSTTRK:	DS	2		;host track number
HSTSEC:	DS	1		;host sector number
HSTDSK:	DS	1		;host disk number
;
HSTWRT:	DS	1		;host written flag
HSTACT:	DS	1		;host active flag
UNACNT:	DS	1		;unalloc rec cnt
RTCNT:	DS	1		;disk retry counter
SEEKRTY:DS	1		;seek retry counter
ERFLAG:	DS	1		;error reporting
RSFLAG:	DS	1		;read sector flag
READOP:	DS	1		;1 if read operation
WRTYPE:	DS	1		;write operation type
;
	IF	MTOM
BLKMVS:	DS	2		;dma m/m blk move size
	ENDIF
;
CHNGFL:	DS	1		;new dsk change boolean
OLDDSK:	DS	1		;last drive select save
DMAADD:	DS	2		;dma address
;
	IF	KEYINT
KEYBUF:	DS	BUFLEN		;keyboard intrp buffer
	ENDIF
;
	IF	TURBO
	MDLCHK			;alloc & check for turbo
	DB	0
	ENDIF
